;
; Description: un petit programme qui crypte/decrypte un fichier quelconque
;

;
; Directives de l'ASSEMBLEUR
;
.686P												;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX													;; pour activer les instructions mmx
.XMM													;; pour activer les instructions sse,sse2 (donc l pentium 3 minimum)
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED											;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP											;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE										;; optionel: rends les identifiants sensibles  la casse de caractres


;
; Fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; Equivalences
;

; identifiants ressources
Rsrc_IDI_Icone_32			EQU 532

Rsrc_IDD_CryFich_Principal		EQU 2000
Rsrc_IDC_CryFich_Principal_C		EQU 2001
Rsrc_IDC_CryFich_Fichier			EQU 2002
Rsrc_IDC_CryFich_Nom_Fichier		EQU 2003
Rsrc_IDC_CryFich_Charger_Fichier	EQU 2004
Rsrc_IDC_CryFich_Crypter_Fichier	EQU 2005
Rsrc_IDC_CryFich_Sauver_Fichier	EQU 2006
Rsrc_IDC_CryFich_Groupe_Clef		EQU 2007
Rsrc_IDC_CryFich_Clef			EQU 2008
Rsrc_IDC_CryFich_Valeur_Clef		EQU 2009
Rsrc_IDC_CryFich_Entrer_Clef		EQU 2010
Rsrc_IDC_CryFich_Charger_Clef		EQU 2011
Rsrc_IDC_CryFich_Generer_Clef		EQU 2012
Rsrc_IDC_CryFich_Sauver_Clef		EQU 2013

Rsrc_IDD_Insuffisant		EQU 2100
Rsrc_IDC_Insuffisant_C		EQU 2101
Rsrc_IDC_Desole			EQU 2102
Rsrc_IDC_Temps_Changer		EQU 2103

Rsrc_IDD_Quitter			EQU 2200
Rsrc_IDC_Quitter_C			EQU 2201
Rsrc_IDC_Vraiment_quitter	EQU 2202
Rsrc_IDC_Hum_Oui			EQU 2203
Rsrc_IDC_Ah_Ca_Non			EQU 2204

Rsrc_IDD_Entree_Clef		EQU 2300
Rsrc_IDC_Entree_Clef_C		EQU 2301
Rsrc_IDC_Valeur_Hexa		EQU 2302
Rsrc_IDC_Edition			EQU 2303
Rsrc_IDC_Valider			EQU 2304

Rsrc_IDD_Erreur_Clef		EQU 2400
Rsrc_IDC_Erreur_Clef_C		EQU 2401
Rsrc_IDC_Invalide			EQU 2402
Rsrc_IDC_Hors_Fichier		EQU 2403
Rsrc_IDC_Ooops				EQU 2404


;
; Prototypes
;
GestionnaireMessagesBoiteDialogueCrypteurDecrypteur			PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoitesDialogue	PROTO :DWORD,:DWORD,:DWORD,:DWORD


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT							;; pour un total de 16 octets
	_Instance_			DWORD ?						;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?						;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?						;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT									;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?						;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?						;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?						;; pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS


.DATA
;
; CONSTANTES et VARIABLES
;

Instance_Application			DWORD ?
Instance_Boite_Dialogue_Principale	DWORD ?
Instance_Boites_Dialogue			DWORD ?
Pointeur_Ligne_Commandes			DWORD ?
Pointeur_Temporaire				DWORD ?

CryFich_Temoin_Statut_Fichier			DWORD ?
CryFich_Temoins_Boites_De_Dialogue		DWORD ?
CryFich_Temoins_Activations			DWORD 011100b

CryFich_Clef_Utilisee					DWORD ?
CryFich_Valeur_Decalage_Fichier			DWORD ?
CryFich_Longueur_Bloc_Fichier_Temporaire	DWORD ?
CryFich_Longueur_Chaine_Nom				DWORD ?


CryFich_Chaine_Nom_Fichier_Depart		BYTE "Aucun",0
CryFich_Chaine_Nom_Fichier			BYTE MAX_PATH dup (?)			;; MAX_PATH = 260
CryFich_Chaine_Nom_Clef				BYTE MAX_PATH dup (?)			;; MAX_PATH = 260
CryFich_Chaine_Clef_Utilisee			BYTE "Aucune",0,0,0,0,0,0,0,0,0,0,0,0

CryFich_Chaine_Separation_Ligne_Commande	BYTE '" "',0
CryFich_Chaine_Fin_Commande				BYTE '"',0
CryFich_Chaine_Extension_Crypted			BYTE ".crypted",0
CryFich_Chaine_Extension_Cuk				BYTE ".cuk",0
Chaine_Separation_Chemin_Nom				BYTE "\",0
Chaine_Separation_Nom_Extension			BYTE ".",0

;Message_Fichier_Crypte			BYTE "Fichier crypt !",0
;Message_Fichier_Decrypte			BYTE "Fichier dcrypt !",0
;Message_Erreur_Clef				BYTE "La valeur spcifie n'est pas valide !",0
;Message_Erreur_Decalage			BYTE "Le dcalage ne peut pas etre suprieur ou gal  la taille du fichier...",13,10,"la clef utilise n'est pas invalide",0
;Message_Erreur_Nom_Fichier		BYTE "Le nom du fichier ne peut pas se situer hors du fichier crypt...",13,10,"la clef utilise n'est pas valide",0
;Message_Erreur_02				BYTE "Un des nombres spcifis n'est pas valide !  ",13,10,"ou ncessite plus qu'une simple prcision !",0

CryFich_Chaine_Filtre_De_Selection_Fichiers			BYTE "Tous fichiers (*.*)",0,"*.*",0,0
CryFich_Chaine_Filtre_De_Selection_Fichiers_Clefs		BYTE "Clefs de cryptage/dcryptage (*.cuk)",0,"*.cuk",0,"Tous fichiers (*.*)",0,"*.*",0,0
;CryFich_Chaine_Filtre_De_Selection_Fichiers_Compresses	BYTE "Fichiers compresss (*.7z,*.lha,*.rar,*.zip)",0,"*.7z;*.lha;*.rar;*.zip",0,"Tous fichiers (*.*)",0,"*.*",0,0
CryFich_Chaine_Filtre_De_Selection_Fichiers_Cryptes		BYTE "Fichiers crypts (*.crypted)",0,"*.crypted",0,"Tous fichiers (*.*)",0,"*.*",0,0
;CryFich_Chaine_Filtre_De_Selection_Fichiers_Donnees		BYTE "Donnes (*.dat,*.raw)",0,"*.dat;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
;CryFich_Chaine_Filtre_De_Selection_Fichiers_Executables	BYTE "Executables (*.exe,*.hlp)",0,"*.exe;*.hlp",0,"Tous fichiers (*.*)",0,"*.*",0,0
;CryFich_Chaine_Filtre_De_Selection_Fichiers_Images		BYTE "Images (*.bmp,*.gif,*.jpg,*.raw)",0,"*.bmp;*.gif;*.jpg;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
;CryFich_Chaine_Filtre_De_Selection_Fichiers_Textes		BYTE "Textes (*.asm,*.doc,*.inc,*.txt,*.x)",0,"*.asm;*.doc;*.inc;*.txt;*.x",0,"Tous fichiers (*.*)",0,"*.*",0,0

CryFich_Chaine_Extension_Clef_Par_Defaut			BYTE "cuk",0			;; abbrviation de "crypt uncrypt key"
;Chaine_Extension_Compresse_Par_Defaut		BYTE "zip",0
CryFich_Chaine_Extension_Crypte_Par_Defaut			BYTE "crypted",0		;; fichier crypt
;Chaine_Extension_Donnees_Par_Defaut		BYTE "dat",0
;Chaine_Extension_Executable_Par_Defaut		BYTE "exe",0
;Chaine_Extension_Image_Par_Defaut			BYTE "bmp",0
;Chaine_Extension_Texte_Par_Defaut			BYTE "txt",0

Chaine_Type_De_Selection_Chargement_Fichier	BYTE "Dfinissez le fichier  charger.",0
Chaine_Type_De_Selection_Sauvegarde_Fichier	BYTE "Dfinissez le fichier  sauvegarder.",0
CryFich_Chaine_Type_De_Selection_Chargement_Clef	BYTE "Dfinissez la clef  charger.",0
CryFich_Chaine_Type_De_Selection_Sauvegarde_Clef	BYTE "Dfinissez la clef  sauvegarder.",0


;
; Donnes STRUCTUREES
;
ALIGN 16
Instance_Memoire					_Informations_Memoire_ <?>
ALIGN 16
CryFich_Tampon_Bloc_Fichier			_Bloc_Memoire_ <?>
ALIGN 16
CryFich_Tampon_Bloc_Clef				_Bloc_Memoire_ <?>

; enfin les structures pour windows...
ALIGN 16
CryFich_Coordonnees_Fenetre			RECT <?>					;; 4 Dwords (x,y du coin suprieur gauche et x,y du coin infrieur droit)
;ALIGN 16
;Cadre_Ecran					RECT <?>					;; 4 Dwords
;ALIGN 16
;Informations_Fenetre			WNDCLASSEX <?>				;; 12 Dwords
; note : la structure BITMAPINFO est dcompose, parcequ'il semble qu'il y ai des difficults pour assembler
; du code lorsque la premire valeur d'une structure est une autre structure...
ALIGN 16
Informations_Bitmap				BITMAPINFOHEADER <?>		;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords) + bmiColors (RGBQUAD) (4 octets)
ALIGN 16												;; )
Informations_Bitmap_Suite_1		RGBQUAD <?>				;; )
ALIGN 16
Informations_Messages_OS			MSG <?>					;; 5 Dwords + 2 Words


.CODE
;
; Macros
;


.CODE
;
; les procdures gnriques
;
INCLUDE GenericProcs.asm


.CODE
;
; les procdures spcifiquement cres pour le programme
;

ALIGN 16
;
; PROCEDURE DE GESTION DES MESSAGES WINDOWS POUR LA BOITE DE DIALOGUE DU CRYPTEUR/DECRYPTEUR DE FICHIERS
;
GestionnaireMessagesBoiteDialogueCrypteurDecrypteur PROC HWndGMCry:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; initialisation des controleurs
;
		cmp eax,WM_INITDIALOG							;; comparer eax  WM_INITDIALOG
		jne GMFinInitialisationControleurs					;; si c'est diffrent, aller GMFinInitialisationControleurs
		invoke LoadIcon,HWndGMCry,Rsrc_IDI_Icone_32
		invoke SetClassLong,HWndGMCry,GCL_HICON,eax

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		mov esi,HWndGMCry								;; ) positionner la fentre outil
		mov edi,OFFSET CryFich_Coordonnees_Fenetre			;; )
		call PositionnerFenetreOutil						;; )

; afficher aucun comme fichier (ou le nom du fichier, si argument)
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Nom_Fichier,OFFSET CryFich_Chaine_Nom_Fichier		;; afficher le texte

; dsactiver crypter/dcrypter au dpart
		bt CryFich_Temoins_Activations,2					;; crypter / dcrypter est toujours dsactiv ?
		jnc EviterDesactiverCrypterDecrypter				;; si ce n'est pas le cas, aller EviterDesactiverCrypterDecrypter
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Crypter_Fichier		;; obtenir les info de l'ID
		invoke EnableWindow,eax,FALSE						;; dsactiver le control correspondant
EviterDesactiverCrypterDecrypter:

; dsactiver sauvegarder le fichier au dpart
		bt CryFich_Temoins_Activations,3					;; sauvegarder le fichier est toujours dsactiv ?
		jnc EviterDesactiverSauvegardeFichier				;; si ce n'est pas le cas, aller EviterDesactiverSauvegardeFichier
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Sauver_Fichier		;; obtenir les info de l'ID
		invoke EnableWindow,eax,FALSE						;; dsactiver le control correspondant
EviterDesactiverSauvegardeFichier:

; afficher la clef
		mov eax,CryFich_Clef_Utilisee						;; lire la clef
		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee			;; placer l'adresse de la chaine ascii correspondante dans esi
;		call ConvertirValeurEnChaineDecimale				;; ) convertir la valeur en eax en chaine ascii
		call ConvertirValeurEnChaineHexa					;; )
;		call ConvertirValeurEnChaineHexaPleine				;; )
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Valeur_Clef,OFFSET CryFich_Chaine_Clef_Utilisee		;; afficher le texte

; dsactiver sauvegarder la clef au dpart
		bt CryFich_Temoins_Activations,4					;; sauvegarder la clef est toujours dsactiv ?
		jnc EviterDesactiverSauvegardeClef					;; si ce n'est pas le cas, aller EviterDesactiverSauvegardeClef
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Sauver_Clef		;; obtenir les info de l'ID
		invoke EnableWindow,eax,FALSE						;; dsactiver le control correspondant
EviterDesactiverSauvegardeClef:

; initialiser la slection de fichier
; eax = instance de l'application
; ebx = instance de la fentre (HWnd/HWndDlg/etc...)
; ecx = adresse (offset) de la chaine du titre de slection par dfaut
; edx = adresse (offset) de la chaine du nom du fichier (a recevoir, ou  dfinir)
; esi = adresse (offset) de la chaine des filtres de slection par dfaut
		mov eax,Instance_Boite_Dialogue_Principale
		mov ebx,HWndGMCry									;; instance fentre
		mov ecx,OFFSET Chaine_Type_De_Selection_Chargement_Fichier		;; titre de la boite de dialogue
		mov edx,OFFSET CryFich_Chaine_Nom_Fichier					;; dfini par les fonctions Open et Close
		mov esi,OFFSET CryFich_Chaine_Filtre_De_Selection_Fichiers		;; filtre utilis
		call InitialiserSelectionFichier					;; et initialiser la slection
	ret												;; retourner
GMFinInitialisationControleurs:


;;
;; initialisation de la fentre
;;
;		cmp eax,WM_CREATE
;		jne GMFinInitialisation							;; si c'est diffrent, aller GMFinInitialisation
;
;	ret												;; retourner
;GMFinInitialisation:

;;
;; dessin de la fentre
;;
;		cmp eax,WM_PAINT
;		jne GMFinMiseAJourEcran							;; si c'est diffrent, aller GMFinMiseAJourEcran
;		invoke BeginPaint,HWndGMCry,ADDR DessinEcran
;		mov hDC,eax
;		invoke ENDPaint,HWndGMCry,ADDR DessinEcran
;	Retourner 0										;; retourner
;GMFinMiseAJourEcran:


;
; ici, les commandes gnres par la souris sur les menus, ou les controlleurs, grs par windows...
;
		cmp eax,WM_COMMAND								;; une commande est entre ?
		jne GMFinCommandes								;; si ce n'est pas le cas, aller GMFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;

;
; charger un fichier
;
		cmp eax,Rsrc_IDC_CryFich_Charger_Fichier			;; charger un fichier ?
		jne GMPasChargerFichier							;; si c'est diffrent, aller GMPasChargerFichier
; nettoyer la mmoire ?
		bt CryFich_Temoins_Activations,0					;; tester le temoin pour le bloc mmoire
		jnc EviterPurgerMemoire							;; si c'est inutilis, aller EviterPurgerMemoire
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour notre tampon fichier
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; )
		call SupprimerFichierEnMemoire					;; )
EviterPurgerMemoire:
; dfinir le type de fichier  charger
		mov eax,HWndGMCry								;; instance de la fentre
		mov ebx,OFFSET Chaine_Type_De_Selection_Chargement_Fichier		;; titre de la boite de dialogue
		mov ecx,OFFSET CryFich_Chaine_Nom_Fichier					;; dfini par les fonctions Open et Close
		mov edx,OFFSET CryFich_Chaine_Filtre_De_Selection_Fichiers		;; les filtres de slection
		mov esi,0										;; extension par dfaut (ici, rien)
		call ObtenirNomFichierACharger					;; obtenir la slection
; un fichier  charger ?
		test eax,eax									;; fixer les flags de eax
		jz PasDeFichierCharge							;; si c'est gal  0, aller PasDeFichierCharge
; le charger
		mov esi,OFFSET Instance_Memoire					;; lire l'instance mmoire
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; lire la structure _Bloc_Memoire_ correspondante
		call ChargerFichier_Customisee					;; et charger le fichier dans l'espace rserv 
; ici, le fichier est en mmoire avec sa taille
; et un espace  t rserv : 260 octets (MAX_PATH) ont t rajouts pour rajouter le nom+extension juste aprs,
; ainsi qu'un dword suplmentaire pour la taille du fichier
		bts CryFich_Temoins_Activations,0					;; placer le tmoin de bloc mmoire utilis

; afficher le nom du fichier
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Nom_Fichier,ADDR CryFich_Chaine_Nom_Fichier		;; afficher le texte
; activer le cryptage/dcryptage
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Crypter_Fichier		;; obtenir les info de l'ID
		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
		btr CryFich_Temoins_Activations,2					;; enlever le tmoin de cryptage / dcryptage
; activer la sauvegarde de fichier
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Sauver_Fichier		;; obtenir les info de l'ID
		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
		btr CryFich_Temoins_Activations,3					;; enlever le tmoin de sauvegarde fichier

;
; on va tester si le fichier charg est un fichier  crypter ou  dcrypter
;

; obtenir la taille de la chaine nom+extension
		mov esi,OFFSET CryFich_Chaine_Nom_Fichier			;; placer l'adresse de la chaine nom+extension
		call ObtenirTailleChaineAscii						;; et obtenir sa taille/longueur
; comparer une chane de caractres  une autre, sans tenir compte de la casse de caractres
		mov esi,OFFSET CryFich_Chaine_Nom_Fichier			;; placer l'adresse de la chaine nom+extension
		add esi,eax									;; ajouter la taille de la chaine - 8  l'adresse en esi
		sub esi,8										;; enlever 8 (.crypted)  esi
		mov edi,OFFSET CryFich_Chaine_Extension_Crypted		;; placer l'adresse de l'extension ".crypted" dans edi
		call ComparerChainesAscii_NonSensibleCasse			;; comparer les chanes sans tenir compte de la casse
; eax = -1 si les chanes sont semblables, sinon eax contient la position (l'octet du bloc) o se situe la premire diffrence
		test eax,eax									;; fixer les flags de eax
		jns FichierACrypter								;; si ce n'est pas sign, aller FichierACrypter

FichierADecrypter:
; mettre  jour le tmoin
		bts CryFich_Temoin_Statut_Fichier,0				;; tmoin, comme quoi le fichier est crypt
PasDeFichierCharge:
	ret												;; retourner

FichierACrypter:
; copier la chaine nom+extension  la suite du bloc fichier en mmoire
		mov eax,CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_		;; copier la taille du fichier dans eax
		mov CryFich_Longueur_Bloc_Fichier_Temporaire,eax		;; sauvegarder la taille du fichier temporairement
		mov esi,OFFSET CryFich_Chaine_Nom_Fichier			;; placer l'adresse de la chane nom+extension dans esi
		mov edi,CryFich_Tampon_Bloc_Fichier._Pointeur_		;; placer l'adresse de dpart des donnes dans edi
		add edi,eax									;; ajouter la taille du bloc mmoire  cette adresse en edi
		call CopierChaineAscii							;; copier/ajouter la chane ascii  cette endroit
; ici, on va manipuler les infos pour pouvoir inscrire la taille du fichier (elle est ncessaire, sinon il faut placer la chaine devant ce qui complique tout...)
		add eax,DWORD+1								;; augmenter la taille obtenue en eax du 0 de fin de chane et le dword pour la taille du fichier
		mov CryFich_Longueur_Chaine_Nom,eax				;; sauvegarder la longueur de la chane (+ le 0 de fin de chane)
		add CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_,eax		;; ajouter la longeur de la chane  la taille du bloc
		add edi,eax									;; ajouter cette longueur  l'adresse de dpart (augment de la taille du fichier)
		sub edi,DWORD									;; enlever 1 dword (celui de la taille du fichier)  edi
		mov eax,CryFich_Longueur_Bloc_Fichier_Temporaire		;; relire la taille du fichier temporairement
		mov DWORD PTR [edi],eax							;; et placer la taille du fichier  cet emplacement
; mettre  jour le tmoin
		btr CryFich_Temoin_Statut_Fichier,0				;; tmoin, comme quoi le fichier n'est pas crypt
	ret												;; retourner
GMPasChargerFichier:

;
; crypter / dcrypter
;
		cmp eax,Rsrc_IDC_CryFich_Crypter_Fichier			;; crypter dcrypter ?
		jne GMPasCrypterDecrypter						;; si c'est diffrent, aller GMPasCrypterDecrypter
; lire la clef
		mov eax,CryFich_Clef_Utilisee						;; lire la clef
		mov _Nombres_Aleatoires_,eax						;; et la recopier dans la variable servant pour la gnration des nombres alatoires
; gnrer un nombre alatoire entre 0 et la taille du fichier + nom+extension -1
		mov ebx,CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_		;; placer la taille du bloc dans ebx
		dec ebx										;; enlever 1  taille du fichier + nom+extension
		call GenererNombreAleatoire						;; gnrer le nombre qui sera la valeur de dcalage du fichier
		inc eax										;; pour tre sur de ne pas avoir 0 ou la taille
		mov CryFich_Valeur_Decalage_Fichier,eax				;; sauvegarder la valeur

; test fichier  crypter/dcrypter
		bt CryFich_Temoin_Statut_Fichier,0					;; le fichier est crypt ?
		jc DecrypterFichier								;; si le flag carry est positionn, aller DecrypterFichier

CrypterFichier:
; dfinir le nom par dfaut
		invoke GetCurrentDirectory,MAX_PATH,ADDR _Fichier_Chaine_Chemin_Temporaire_
		mov esi,OFFSET CryFich_Chaine_Nom_Fichier			;; placer l'adresse de la chaine nom+extension dans esi
		mov edi,esi									;; et dans edi
		call ObtenirTailleChaineAscii						;; et obtenir sa taille/longueur
		add esi,eax									;; ajouter la taille obtenue  esi
ScannerChaine:
		cmp BYTE PTR [esi],"."							;; comparer l'octet en esi au point de sparation
		je FinDeChaine									;; si c'est le point, aller FinDeChaine
		dec esi										;; sinon, dcrmenter l'adresse de lecture
		cmp esi,edi									;; la comparer  celle de dbut de chane
		jnb ScannerChaine								;; tant que ce n'est pas infrieur, aller ScannerChaine
		lea esi,[edi+eax]								;; sinon, placer l'adresse de dpart augmente de la taille dans esi
FinDeChaine:
		mov BYTE PTR [esi],0							;; placer le 0 de fin de chane dans l'octet en esi (ce qui supprimera l'extension)
; fusionner le nom avec l'extension crypted
		mov edi,OFFSET CryFich_Chaine_Nom_Fichier
		invoke FusionnerMultiplesChainesAscii,2,ADDR Chaine_Separation_Nom_Extension,ADDR CryFich_Chaine_Extension_Crypte_Par_Defaut
; fusionner le chemin avec le nom originel du fichier
		mov edi,OFFSET _Fichier_Chaine_Chemin_Temporaire_
		invoke FusionnerMultiplesChainesAscii,2,ADDR Chaine_Separation_Chemin_Nom,ADDR CryFich_Chaine_Nom_Fichier
; mettre le nom du fichier  jour
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Nom_Fichier,ADDR CryFich_Chaine_Nom_Fichier		;; afficher le texte

; dcaler le bloc mmoire
		mov eax,CryFich_Valeur_Decalage_Fichier				;; placer le pas de dcalage dans eax
		mov esi,OFFSET Instance_Memoire					;; placer l'instance mmoire dans esi
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; placer l'adresse du bloc mmoire  dcaler dans edi
		call DecalerBlocMemoire							;; et dcaler le bloc
; crypter le bloc mmoire
;		mov eax,CryFich_Clef_Utilisee							;; lire la clef
		mov eax,_Nombres_Aleatoires_						;; ici, c'est pour viter que la mme valeur soit utilise 2 fois
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; lire la structure _Bloc_Memoire_ correspondante
		call CrypterDecrypterBlocMemoire					;; crypter
; message fichier crypt
		bts CryFich_Temoin_Statut_Fichier,0				;; tmoin, comme quoi le fichier est crypt
	ret												;; retourner

DecrypterFichier:
; dcrypter le bloc mmoire
;		mov eax,CryFich_Clef_Utilisee							;; lire la clef
		mov eax,_Nombres_Aleatoires_						;; ici, c'est pour viter que la mme valeur soit utilise 2 fois
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; lire la structure _Bloc_Memoire_ correspondante
		call CrypterDecrypterBlocMemoire					;; dcrypter
; dcaler le bloc mmoire
		mov eax,CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_		;; placer la taille du bloc mmoire dans eax
		cmp eax,CryFich_Valeur_Decalage_Fichier
		jle MessageErreurClef
		sub eax,CryFich_Valeur_Decalage_Fichier				;; enlever le pas de dcalage  eax
		mov esi,OFFSET Instance_Memoire					;; placer l'instance mmoire dans esi
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; placer l'adresse du bloc mmoire  dcaler dans edi
		call DecalerBlocMemoire							;; et dcaler le bloc
; message fichier dcrypt
		btr CryFich_Temoin_Statut_Fichier,0				;; tmoin, comme quoi le fichier est dcrypt

; dfinir le nom par dfaut
		invoke GetCurrentDirectory,MAX_PATH,ADDR _Fichier_Chaine_Chemin_Temporaire_		;; obtenir le rpertoire
		mov esi,CryFich_Tampon_Bloc_Fichier._Pointeur_			;; ) obtenir le nom originel du fichier
		add esi,CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_		;; )
		sub esi,DWORD										;; )
		mov esi,DWORD PTR [esi]								;; )

		cmp esi,CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_		;; placer la taille du bloc mmoire dans eax
		jae MessageErreurClef

		add esi,CryFich_Tampon_Bloc_Fichier._Pointeur_		;; )
		mov edi,OFFSET CryFich_Chaine_Nom_Fichier			;; )
		call CopierChaineAscii							;; )
; fusionner le chemin avec le nom originel du fichier
		mov edi,OFFSET _Fichier_Chaine_Chemin_Temporaire_
		invoke FusionnerMultiplesChainesAscii,2,ADDR Chaine_Separation_Chemin_Nom,ADDR CryFich_Chaine_Nom_Fichier
; mettre le nom du fichier  jour
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Nom_Fichier,ADDR CryFich_Chaine_Nom_Fichier		;; afficher le texte
	ret												;; retourner

MessageErreurClef:
; placer "aucun" dans la chane qui sera traite en permanence
		mov esi,OFFSET CryFich_Chaine_Nom_Fichier_Depart		;; placer l'adresse source
		mov edi,OFFSET CryFich_Chaine_Nom_Fichier			;; placer l'adresse de destination
		call CopierChaineAscii							;; et copier la chaine
		bts CryFich_Temoins_Activations,2					;; dsactiver le bouton de cryptage / dcryptage
		bts CryFich_Temoins_Activations,3					;; dsactiver le bouton de sauvegarde fichier

; et afficher le message d'erreur
		bts CryFich_Temoins_Boites_De_Dialogue,1			;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
;		invoke EndDialog,HWndGMCry,0						;; sinon, fermer la boite de dialogue
		invoke EnableWindow,HWndGMCry,FALSE
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Erreur_Clef,0,ADDR GestionnaireMessagesBoitesDialogue,0
		invoke EnableWindow,HWndGMCry,TRUE
	ret												;; retourner
GMPasCrypterDecrypter:

;
; sauvegarder le fichier
;
		cmp eax,Rsrc_IDC_CryFich_Sauver_Fichier				;; sauvegarder le fichier ?
		jne GMPasSauvegarderFichier						;; si c'est diffrent, aller GMPasSauvegarderFichier

; test fichier  crypt/dcrypt
		bt CryFich_Temoin_Statut_Fichier,0					;; le fichier est crypt ?
		jnc SauvegarderFichierDecrypte					;; si le flag carry est positionn, aller SauvegarderFichierDecrypte

SauvegarderFichierCrypte:
; dfinir le type de fichier  sauvegarder
		mov eax,HWndGMCry								;; instance de la fentre
		mov ebx,OFFSET Chaine_Type_De_Selection_Sauvegarde_Fichier		;; titre de la boite de dialogue
		mov ecx,OFFSET CryFich_Chaine_Nom_Fichier			;; dfini par les fonctions Open et Close
		mov edx,OFFSET CryFich_Chaine_Filtre_De_Selection_Fichiers_Cryptes		;; les filtres de slection
		mov esi,0										;; pas d'extension par dfaut (elle a dj t dfinie)
		call ObtenirNomFichierASauvegarder					;; obtenir le nom
; un fichier  sauvegarder ?
		test eax,eax									;; fixer les flags de eax
		jz PasDeFichierCrypteASauvegarder					;; si c'est gal  0, aller PasDeFichierCrypteASauvegarder
; la taille du fichier est inscripte, alors on peut sauvegarder
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; lire la structure _Bloc_Memoire_ correspondante
		call SauvegarderFichier							;; et sauvegarder le fichier depuis l'espace rserv 
; mettre le nom du fichier  jour
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Nom_Fichier,ADDR CryFich_Chaine_Nom_Fichier		;; afficher le texte

PasDeFichierCrypteASauvegarder:
	ret												;; retourner

SauvegarderFichierDecrypte:
; modifier les infos concernant la taille du bloc mmoire, pour ne sauvegarder que le fichier originel
		mov eax,CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_		;; placer la taille du bloc mmoire en cours dans eax
		mov CryFich_Longueur_Bloc_Fichier_Temporaire,eax			;; sauvegarder la taille du fichier temporairement
		add eax,CryFich_Tampon_Bloc_Fichier._Pointeur_		;; ajouter l'adresse de dpart du bloc mmoire
		sub eax,DWORD									;; enlever 1 dword  cette adresse
		mov eax,DWORD PTR [eax]							;; placer la taille originel du fichier dans eax
		mov CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_,eax		;; sauvegarder la taille du bloc mmoire originel
; dfinir le type de fichier  sauvegarder
		mov eax,HWndGMCry								;; instance de la fentre
		mov ebx,OFFSET Chaine_Type_De_Selection_Sauvegarde_Fichier		;; titre de la boite de dialogue
		mov ecx,OFFSET CryFich_Chaine_Nom_Fichier			;; dfini par les fonctions Open et Close
		mov edx,OFFSET CryFich_Chaine_Filtre_De_Selection_Fichiers		;; pas de filtre de slection
		mov esi,0										;; pas d'extension par dfaut (c'est l'extension originelle du fichier)
		call ObtenirNomFichierASauvegarder					;; obtenir le nom
; un fichier  sauvegarder ?
		test eax,eax									;; fixer les flags de eax
		jz PasDeFichierDecrypteASauvegarder				;; si c'est gal  0, aller PasDeFichierDecrypteASauvegarder
; la taille du fichier est inscripte, alors on peut sauvegarder
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; lire la structure _Bloc_Memoire_ correspondante
		call SauvegarderFichier							;; et sauvegarder le fichier depuis l'espace rserv 

PasDeFichierDecrypteASauvegarder:
; restaurer la taille du bloc mmoire que l'on utilise
		mov eax,CryFich_Longueur_Bloc_Fichier_Temporaire		;; relire la taille du fichier temporairement
		mov CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_,eax		;; replacer la taille
; mettre le nom du fichier  jour
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Nom_Fichier,ADDR CryFich_Chaine_Nom_Fichier		;; afficher le texte

	ret												;; retourner
GMPasSauvegarderFichier:

;
; entrer une clef
;
		cmp eax,Rsrc_IDC_CryFich_Entrer_Clef				;; entrer une clef ?
		jne GMPasEntrerClef								;; si c'est diffrent, aller GMPasEntrerClef

		bts CryFich_Temoins_Boites_De_Dialogue,1			;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
;		invoke EndDialog,HWndGMCry,0						;; sinon, fermer la boite de dialogue
		invoke EnableWindow,HWndGMCry,FALSE
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Entree_Clef,0,ADDR GestionnaireMessagesBoitesDialogue,0
		invoke EnableWindow,HWndGMCry,TRUE
; mettre  jour l'affichage de la clef
		mov eax,CryFich_Clef_Utilisee						;; lire la clef entre
		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee			;; placer l'adresse de la chaine ascii correspondante dans esi
;		call ConvertirValeurEnChaineDecimale				;; ) convertir la valeur en eax en chaine ascii
		call ConvertirValeurEnChaineHexa					;; )
;		call ConvertirValeurEnChaineHexaPleine				;; )
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Valeur_Clef,OFFSET CryFich_Chaine_Clef_Utilisee		;; et mise  jour de la chaine  l'cran
; activer la sauvegarde de la clef
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Sauver_Clef		;; obtenir les info de l'ID
		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
		btr CryFich_Temoins_Activations,4					;; enlever le tmoin de sauvegarde clef
	ret												;; retourner
GMPasEntrerClef:

;
; charger une clef
;
		cmp eax,Rsrc_IDC_CryFich_Charger_Clef				;; charger une clef ?
		jne GMPasChargerClef							;; si c'est diffrent, aller GMPasChargerClef

; dfinir le type de fichier  charger
		mov eax,HWndGMCry								;; instance de la fentre
		mov ebx,OFFSET CryFich_Chaine_Type_De_Selection_Chargement_Clef		;; titre de la boite de dialogue
		mov ecx,OFFSET CryFich_Chaine_Nom_Clef				;; dfini par les fonctions Open et Close
		mov edx,OFFSET CryFich_Chaine_Filtre_De_Selection_Fichiers_Clefs		;; les filtres de slection
		mov esi,OFFSET CryFich_Chaine_Extension_Clef_Par_Defaut		;; extension par dfaut
		call ObtenirNomFichierACharger
; une clef  charger ?
		test eax,eax									;; fixer les flags de eax
		jz PasDeClefACharger							;; si c'est gal  0, aller PasDeClefACharger
; charger la clef
		mov esi,OFFSET Instance_Memoire					;; lire l'instance mmoire
		mov edi,OFFSET CryFich_Tampon_Bloc_Clef				;; lire la structure _Bloc_Memoire_ correspondante
		call ChargerFichier								;; et charger le fichier dans l'espace rserv 
; lire la clef
		mov eax,CryFich_Tampon_Bloc_Clef._Pointeur_			;; placer l'adresse de dpart des donnes dans eax
		mov eax,DWORD PTR [eax]							;; placer le dword en eax dans eax
		mov CryFich_Clef_Utilisee,eax						;; sauvegarder la clef
; effacer le bloc mmoire devenu inutile
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour notre tampon clef
		mov edi,OFFSET CryFich_Tampon_Bloc_Clef				;; )
		call SupprimerFichierEnMemoire					;; )
; mettre  jour l'affichage de la clef
		mov eax,CryFich_Clef_Utilisee						;; lire la clef
		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee			;; placer l'adresse de la chaine ascii correspondante dans esi
;		call ConvertirValeurEnChaineDecimale				;; ) convertir la valeur en eax en chaine ascii
		call ConvertirValeurEnChaineHexa					;; )
;		call ConvertirValeurEnChaineHexaPleine				;; )
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Valeur_Clef,OFFSET CryFich_Chaine_Clef_Utilisee		;; et mise  jour de la chaine  l'cran
; activer la sauvegarde de la clef
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Sauver_Clef		;; obtenir les info de l'ID
		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
		btr CryFich_Temoins_Activations,4					;; enlever le tmoin de sauvegarde clef
PasDeClefACharger:
	ret												;; retourner
GMPasChargerClef:

;
; gnrer une nouvelle clef
;
		cmp eax,Rsrc_IDC_CryFich_Generer_Clef						;; gnrer une nouvelle clef ?
		jne GMPasNouvelleClef							;; si c'est diffrent, aller GMPasNouvelleClef

; gnrer un nombre alatoire 32 bits
		mov ebx,1										;; placer 1 dans ebx (pour gnrer un nombre alatoire 32 bits)
		call GenererNombreAleatoire						;; gnrer le nombre
		mov CryFich_Clef_Utilisee,eax						;; sauvegarder la clef gnre
		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee			;; placer l'adresse de la chaine ascii correspondante dans esi
;		call ConvertirValeurEnChaineDecimale				;; ) convertir la valeur en eax en chaine ascii
		call ConvertirValeurEnChaineHexa					;; )
;		call ConvertirValeurEnChaineHexaPleine				;; )
		invoke SetDlgItemText,HWndGMCry,Rsrc_IDC_CryFich_Valeur_Clef,OFFSET CryFich_Chaine_Clef_Utilisee		;; et mise  jour de la chaine  l'cran
; activer la sauvegarde de la clef
		invoke GetDlgItem,HWndGMCry,Rsrc_IDC_CryFich_Sauver_Clef		;; obtenir les info de l'ID
		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
		btr CryFich_Temoins_Activations,4					;; enlever le tmoin de sauvegarde clef
	ret												;; retourner
GMPasNouvelleClef:

;
; sauvegarder la clef
;
		cmp eax,Rsrc_IDC_CryFich_Sauver_Clef				;; charger une clef ?
		jne GMPasSauvegarderClef							;; si c'est diffrent, aller GMPasSauvegarderClef

; dfinir le type de fichier  sauvegarder
		mov eax,HWndGMCry								;; instance de la fentre
		mov ebx,OFFSET CryFich_Chaine_Type_De_Selection_Sauvegarde_Clef		;; titre de la boite de dialogue
		mov ecx,OFFSET CryFich_Chaine_Nom_Clef				;; dfini par les fonctions Open et Close
		mov edx,OFFSET CryFich_Chaine_Filtre_De_Selection_Fichiers_Clefs		;; les filtres de slection
		mov esi,OFFSET CryFich_Chaine_Extension_Clef_Par_Defaut		;; extension par dfaut
		call ObtenirNomFichierASauvegarder					;; obtenir le nom
; une clef  sauvegarder ?
		test eax,eax									;; fixer les flags de eax
		jz PasDeClefASauvegarder							;; si c'est gal  0, aller PasDeClefASauvegarder
; la taille du fichier est inscripte, alors on peut sauvegarder
		call SauvegarderFichier_Customise					;; et sauvegarder la clef
PasDeClefASauvegarder:
	ret												;; retourner
GMPasSauvegarderClef:

;
	ret												;; retourner
GMFinCommandes:


;
; ici, les messages concernant la souris :
; WM_LBUTTONDOWN, WM_LBUTTONUP, WM_LBUTTONDBLCLK,
; WM_MBUTTONDOWN, WM_MBUTTONUP, WM_MBUTTONDBLCLK,
; WM_RBUTTONDOWN, WM_RBUTTONUP, WM_RBUTTONDBLCLK, WM_MOUSEMOVE
; retournent le rsultat obtenu par les boutons et le mouvement de la souris.
;

;;
;; bouton gauche press ?
;;
;		cmp eax,WM_LBUTTONDOWN							;; bouton gauche de la souris press ?
;		jne GMPasBoutonSourisGauche						;; si c'est diffrent, aller GMPasBoutonSourisGauche
;
;;	ret												;; retourner
;GMPasBoutonSourisGauche:
;;
;; bouton gauche relach ?
;;
;		cmp eax,WM_LBUTTONUP							;; bouton gauche de la souris relach ?
;		jne GMPasBoutonSourisGaucheRelache					;; si c'est diffrent, aller GMPasBoutonSourisGaucheRelache
;
;;	ret												;; retourner
;GMPasBoutonSourisGaucheRelache:
;;;
;;; double clique gauche ?
;;;
;;		cmp eax,WM_LBUTTONDBLCLK							;; bouton gauche de la souris double clique ?
;;		jne GMPasBoutonSourisGaucheDouble					;; si c'est diffrent, aller GMPasBoutonSourisGaucheDouble
;;
;;;	ret												;; retourner
;;GMPasBoutonSourisGaucheDouble:
;;
;; bouton milieu press ?
;;
;		cmp eax,WM_MBUTTONDOWN							;; bouton milieu de la souris press ?
;		jne GMPasBoutonSourisMilieu						;; si c'est diffrent, aller GMPasBoutonSourisMilieu
;
;;	ret												;; retourner
;GMPasBoutonSourisMilieu:
;;
;;  bouton milieu relach ?
;;
;		cmp eax,WM_MBUTTONUP							;; bouton milieu de la souris relach ?
;		jne GMPasBoutonSourisMilieuRelache					;; si c'est diffrent, aller GMPasBoutonSourisMilieuRelache
;
;;	ret												;; retourner
;GMPasBoutonSourisMilieuRelache:
;;;
;;; double clique milieu ?
;;;
;;		cmp eax,WM_MBUTTONDBLCLK							;; bouton milieu de la souris double clique ?
;;		jne GMPasBoutonSourisMilieuDouble					;; si c'est diffrent, aller GMPasBoutonSourisMilieuDouble
;;
;;;	ret												;; retourner
;;GMPasBoutonSourisMilieuDouble:
;;
;; bouton droit press ?
;;
;		cmp eax,WM_RBUTTONDOWN							;; bouton droit de la souris press ?
;		jne GMPasBoutonSourisDroit						;; si c'est diffrent, aller GMPasBoutonSourisDroit
;
;;	ret												;; retourner
;GMPasBoutonSourisDroit:
;;
;; bouton droit relach ?
;;
;		cmp eax,WM_RBUTTONUP							;; bouton droit de la souris relach ?
;		jne GMPasBoutonSourisDroitRelache					;; si c'est diffrent, aller GMPasBoutonSourisDroitRelache
;
;;	ret												;; retourner
;GMPasBoutonSourisDroitRelache:
;;;
;;; double clique droit ?
;;;
;;		cmp eax,WM_RBUTTONDBLCLK							;; bouton droit de la souris double clique ?
;;		jne GMPasBoutonSourisDroitDouble					;; si c'est diffrent, aller GMPasBoutonSourisDroitDouble
;;
;;;	ret												;; retourner
;;GMPasBoutonSourisDroitDouble:
;;
;; mouvement de la souris ?
;;
;		cmp eax,WM_MOUSEMOVE							;; un mouvement de la souris ?
;		jne GMPasMouvementsSouris						;; si c'est diffrent, aller GMPasMouvementsSouris
;; ici, on traite la rotation par rapport  l'axe Y (mouvement souris X)
;		mov eax,LParam									;; sinon on place LParam (Y (word), X (word)) dans eax
;		and eax,00000FFFFh								;; filtrer eax (pour avoir uniquement le X)
;		mov eax,LParam									;; on place LParam (Y (word), X (word)) dans eax
;		shr eax,16									;; dcaler eax  droite de 16 bits (pour avoir l'Y au bon endroit)
;;		mov eax,WParam									;; pas utile pour le moment...
;	ret												;; retourner
;GMPasMouvementsSouris:


;;
;; mouvement de la molette de la souris ?
;;
;		cmp eax,WM_MOUSEWHEEL							;; un mouvement de la molette de la souris ?
;		jne GMPasMouvementsMoletteSouris					;; si c'est diffrent, aller GMPasMouvementsMoletteSouris
;		and eax,0FFFF0000h								;; ne conserver que les 16 bits suprieurs (ce sont eux qui contiennent les infos)
;		js GMMouvementMoletteSourisSuivant
;; il faut diviser la valeur par 120 (?) pour avoir la valeur de dplacement
;		shr eax,16
;
;
;		jmp GMMouvementMoletteSourisPrecedent
;GMMouvementMoletteSourisSuivant:
;; il faut diviser la valeur par 120 (?) pour avoir la valeur de dplacement
;		neg eax
;		shr eax,16
;
;
;GMMouvementMoletteSourisPrecedent:
;	ret												;; retourner
;GMPasMouvementsMoletteSouris:


;;
;; ici, les messages concernant les touches prsses
;;
;		cmp eax,WM_KEYDOWN
;		jne GMFinTouchePressee							;; si c'est diffrent, aller GMFinTouchePressee
;		mov eax,WParam
;;
;; touche esc presse ?
;;
;		cmp eax,VK_ESCAPE								;; Quitter ?
;		jne GMPasToucheEscPressee						;; si c'est diffrent, aller GMPasToucheEscPressee
;		bts CryFich_Temoins_Boites_De_Dialogue,0					;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
;		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
;	ret												;; retourner
;GMPasToucheEscPressee:
;;
;; touche F1 presse ?
;;
;		cmp eax,VK_F1
;		jne GMPasToucheF1Pressee							;; si c'est diffrent, aller GMPasToucheF1Pressee
;
;	ret												;; retourner
;GMPasToucheF1Pressee:
;;
;; touche F2 presse ?
;;
;		cmp eax,VK_F2
;		jne GMPasToucheF2Pressee							;; si c'est diffrent, aller GMPasToucheF2Pressee
;
;	ret												;; retourner
;GMPasToucheF2Pressee:
;;
;; touche F3 presse ?
;;
;		cmp eax,VK_F3
;		jne GMPasToucheF3Pressee							;; si c'est diffrent, aller GMPasToucheF3Pressee
;
;	ret												;; retourner
;GMPasToucheF3Pressee:
;;
;; touche F4 presse ?
;;
;		cmp eax,VK_F4
;		jne GMPasToucheF4Pressee							;; si c'est diffrent, aller GMPasToucheF4Pressee
;
;	ret												;; retourner
;GMPasToucheF4Pressee:
;;
;; touche F5 presse ?
;;
;		cmp eax,VK_F5
;		jne GMPasToucheF5Pressee							;; si c'est diffrent, aller GMPasToucheF5Pressee
;
;	ret												;; retourner
;GMPasToucheF5Pressee:
;;
;; touche F6 presse ?
;;
;		cmp eax,VK_F6
;		jne GMPasToucheF6Pressee							;; si c'est diffrent, aller GMPasToucheF6Pressee
;
;	ret												;; retourner
;GMPasToucheF6Pressee:
;;
;; touche F7 presse ?
;;
;		cmp eax,VK_F7
;		jne GMPasToucheF7Pressee							;; si c'est diffrent, aller GMPasToucheF7Pressee
;
;	ret												;; retourner
;GMPasToucheF7Pressee:
;;
;; touche F8 presse ?
;;
;		cmp eax,VK_F8
;		jne GMPasToucheF8Pressee							;; si c'est diffrent, aller GMPasToucheF8Pressee
;
;	ret												;; retourner
;GMPasToucheF8Pressee:
;;
;; touche F9 presse ?
;;
;		cmp eax,VK_F9
;		jne GMPasToucheF9Pressee							;; si c'est diffrent, aller GMPasToucheF9Pressee
;
;	ret												;; retourner
;GMPasToucheF9Pressee:
;;
;; touche F10 presse ?
;;
;		cmp eax,VK_F10
;		jne GMPasToucheF10Pressee						;; si c'est diffrent, aller GMPasToucheF11Pressee
;
;	ret												;; retourner
;GMPasToucheF10Pressee:
;;
;; touche F11 presse ?
;;
;		cmp eax,VK_F11
;		jne GMPasToucheF11Pressee						;; si c'est diffrent, aller GMPasToucheF11Pressee
;
;	ret												;; retourner
;GMPasToucheF11Pressee:
;;
;; touche F12 presse ?
;;
;		cmp eax,VK_F12
;		jne GMPasToucheF12Pressee						;; si c'est diffrent, aller GMPasToucheF12Pressee
;
;	ret												;; retourner
;GMPasToucheF12Pressee:
;;
;; touche haut presse ?
;;
;		cmp eax,VK_UP
;		jne GMPasToucheHautPressee						;; si c'est diffrent, aller GMPasToucheHautPressee
;
;	ret												;; retourner
;GMPasToucheHautPressee:
;;
;; touche bas presse ?
;;
;		cmp eax,VK_DOWN
;		jne GMPasToucheBasPressee						;; si c'est diffrent, aller GMPasToucheBasPressee
;
;	ret												;; retourner
;GMPasToucheBasPressee:
;;
;; touche gauche presse ?
;;
;		cmp eax,VK_LEFT
;		jne GMPasToucheGauchePressee						;; si c'est diffrent, aller GMPasToucheGauchePressee
;
;	ret												;; retourner
;GMPasToucheGauchePressee:
;;
;; touche droite presse ?
;;
;		cmp eax,VK_RIGHT
;		jne GMPasToucheDroitePressee						;; si c'est diffrent, aller GMPasToucheDroitePressee
;
;	ret												;; retourner
;GMPasToucheDroitePressee:
;;
;; touche page precedente presse ?
;;
;		cmp eax,VK_PGUP								;; touche page prcedente ?
;		jne GMPasTouchePagePrecedantePressee				;; si c'est diffrent, aller GMPasTouchePagePrecedantePressee
;
;	ret												;; retourner
;GMPasTouchePagePrecedantePressee:
;;
;; touche page suivate presse ?
;;
;		cmp eax,VK_PGDN								;; touche page suivante ?
;		jne GMPasTouchePageSuivantePressee					;; si c'est diffrent, aller GMPasTouchePageSuivantePressee
;
;	ret												;; retourner
;GMPasTouchePageSuivantePressee:

;;
;; touche a presse ?
;;
;		cmp eax,VK_A
;		jne GMPasToucheAPressee							;; si c'est diffrent, aller GMPasToucheAPressee
;
;	ret												;; retourner
;GMPasToucheAPressee:


;
;	ret												;; retourner
;GMFinTouchePressee:


;;
;; ici, les messages concernant les touches relaches
;;
;		cmp eax,WM_KEYUP
;		jne GMFinToucheRelachee							;; si c'est diffrent, aller GMFinToucheRelachee
;		mov eax,WParam
;;
;; touche haut relache ?
;;
;		cmp eax,VK_UP
;		jne GMPasToucheHautRelachee						;; si c'est diffrent, aller GMPasToucheHautRelachee
;
;	ret												;; retourner
;GMPasToucheHautRelachee:
;;
;; touche bas relache ?
;;
;		cmp eax,VK_DOWN
;		jne GMPasToucheBasRelachee						;; si c'est diffrent, aller GMPasToucheBasRelachee
;
;	ret												;; retourner
;GMPasToucheBasRelachee:
;;
;; touche gauche relache ?
;;
;		cmp eax,VK_LEFT
;		jne GMPasToucheGaucheRelachee						;; si c'est diffrent, aller GMPasToucheGaucheRelachee
;
;	ret												;; retourner
;GMPasToucheGaucheRelachee:
;;
;; touche droite relache ?
;;
;		cmp eax,VK_RIGHT
;		jne GMPasToucheDroiteRelachee						;; si c'est diffrent, aller GMPasToucheDroiteRelachee
;
;	ret												;; retourner
;GMPasToucheDroiteRelachee:
;;
;; touche page precedente relache ?
;;
;		cmp eax,VK_PGUP								;; touche page prcedente ?
;		jne GMPasTouchePagePrecedanteRelachee				;; si c'est diffrent, aller GMPasTouchePagePrecedanteRelachee
;
;	ret												;; retourner
;GMPasTouchePagePrecedanteRelachee:
;;
;; touche page suivate relache ?
;;
;		cmp eax,VK_PGDN								;; touche page suivante ?
;		jne GMPasTouchePageSuivanteRelachee				;; si c'est diffrent, aller GMPasTouchePageSuivanteRelachee
;
;	ret												;; retourner
;GMPasTouchePageSuivanteRelachee:
;
;
;
;
;;
;	ret												;; retourner
;GMFinToucheRelachee:


;
; fermeture de l'application ?
;
		cmp eax,WM_CLOSE								;; message de fermeture reu ?
		jne GMFinFermeture								;; si c'est diffrent, aller GMFinFermeture
		jmp GMSortir									;; aller GMSortir
	ret												;; retourner
GMFinFermeture:


;
; fin du processus principal
;
		cmp eax,WM_DESTROY								;; fermeture de l'application par la croix ?
		jne GMFinProcessusTermine						;; si c'est diffrent, aller GMFinProcessusTermine
GMSortir:
		bts CryFich_Temoins_Boites_De_Dialogue,0			;; placer le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EnableWindow,HWndGMCry,FALSE
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
		invoke EnableWindow,HWndGMCry,TRUE
	ret												;; retourner
GMFinProcessusTermine:


;
; traitement par dfaut pour les boites de dialogue
;
		xor eax,eax									;; effacer eax
	ret												;; retourner
GestionnaireMessagesBoiteDialogueCrypteurDecrypteur ENDP


;
; gestionnaire de message pour les boites de dialogue supplmentaires
;
GestionnaireMessagesBoitesDialogue PROC HWndGMDlg:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

		cmp eax,WM_COMMAND
		jne GMBDFinCommandes							;; si c'est diffrent, aller GMBDFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,Rsrc_IDC_Temps_Changer					;; Il est temps d'en changer est cliqu ?
		jne GMBDPasTempsChangerMicro						;; si c'est diffrent, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndGMDlg,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,Rsrc_IDC_Hum_Oui							;; Hum... oui est cliqu ?
		jne GMBDPasHumOui								;; si c'est diffrent, aller GMBDPasHumOui
		btr CryFich_Temoins_Boites_De_Dialogue,0			;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMDlg,0						;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; poster le message de sortie
	ret												;; retourner
GMBDPasHumOui:
; Ah a non !
		cmp eax,Rsrc_IDC_Ah_Ca_Non						;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon								;; si c'est diffrent, aller GMBDPasAhCaNon
		btr CryFich_Temoins_Boites_De_Dialogue,0			;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMDlg,0						;; sinon, fermer la boite de dialogue
;		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_CryFich_Principal,0,ADDR GestionnaireMessagesBoiteDialogueCrypteurDecrypteur,0
	ret												;; retourner
GMBDPasAhCaNon:

;
; boite de dialogue pour entrer une clef
;

; valider
		cmp eax,Rsrc_IDC_Valider							;; valider est cliqu ?
		jne GMBDPasEntreeClef							;; si c'est diffrent, aller GMBDPasEntreeClef
; rcuprer la valeur entre
		invoke GetDlgItemText,HWndGMDlg,Rsrc_IDC_Edition,OFFSET CryFich_Chaine_Clef_Utilisee,17		;; 17 maxi
; tester la validit de la chane
		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee			;; placer l'adresse de la chane dans esi
		call TesterValiditeChaineHexadecimale				;; tester la chane
		test eax,eax									;; fixer les flags de eax
		jns ClefNonValide								;; si ce n'est pas sign, aller ClefNonValide
; sinon, la chane est valide alors on va la changer en valeur 32 bits
		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee			;; placer l'adresse de la chane dans esi
		call ConvertirChaineHexaEnValeur					;; obtenir la valeur correspondante
		mov CryFich_Clef_Utilisee,eax						;; sauvegarder la clef
; et sortir de la boite
		btr CryFich_Temoins_Boites_De_Dialogue,1			;; enlever le tmoin de la boite de dialogue pour la clef (bit 1)
		invoke EndDialog,HWndGMDlg,0						;; sinon, fermer la boite de dialogue
;		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_CryFich_Principal,0,ADDR GestionnaireMessagesBoiteDialogueCrypteurDecrypteur,0
ClefNonValide:
	ret												;; retourner
GMBDPasEntreeClef:

;
; boite de dialogue clef non valide
;

; Ooops, erreur de manipulation...
		cmp eax,Rsrc_IDC_Ooops							;; Ooops, erreur de manipulation... est cliqu ?
		jne GMBDPasOoopsErreur							;; si c'est diffrent, aller GMBDPasOoopsErreur
		btr CryFich_Temoins_Boites_De_Dialogue,0			;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndGMDlg,0						;; sinon, fermer la boite de dialogue
;		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_CryFich_Principal,0,ADDR GestionnaireMessagesBoiteDialogueCrypteurDecrypteur,0
	ret												;; retourner
GMBDPasOoopsErreur:


;
	ret												;; retourner
GMBDFinCommandes:


; traitement par dfaut pour les boites de dialogue
		xor eax,eax									;; effacer eax
	ret												;; retourner
GestionnaireMessagesBoitesDialogue ENDP


ALIGN 16
;
; charger un fichier compress en mmoire (dans un bloc de mme taille) (ncessite comdlg32.lib)
;
; Receptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_ qui recevra le fichier
;
; Retourne :
; eax = nombre d'octets lus (ou zro s'il y a une erreur, ou -1 si impossible d'obtenir l'info concernant la taille)
;
; syntaxe : ChargerFichier_Customisee
;
ChargerFichier_Customisee PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; dfinir les flags de lecture
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ;or OFN_HIDEREADONLY
; obtenir la taille (en octets) du fichier
		invoke FindFirstFile,_Fichier_Information_Selection_.lpstrFile,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE						;; comparer eax  -1
		je Label02									;; si c'est gal (erreur pointeur), aller Label02
; sinon, le pointeur est valide
		invoke FindClose,eax							;; alors, supprimer le pointeur dont on n'a plus besion
;		cmp _Fichier_Information_Fichier_.nFileSizeHigh,0		;; ) fichier trop volumineux ?
;		jne Label03									;; )
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow		;; sinon, rcuprer la taille du fichier
; definir la taille du bloc mmoire ncessaire pour charger le fichier
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer cette taille dans x._Taille_Du_Bloc_

; ici c'est pour pouvoir ajouter nom+extension
		add eax,MAX_PATH								;; MAX_PATH = 260
		add eax,DWORD									;; ajouter un dword pour connaitre la taille du fichier

		add eax,000000011h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets) et 1 (pour tre sr d'avoir 1 octet pour un zro final)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_
; lire le fichier
		invoke CreateFile,_Fichier_Information_Selection_.lpstrFile,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax		;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke ReadFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Lus_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_		;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant
		mov eax,_Fichier_Octets_Lus_						;; retourne le nombre d'octets lus dans eax

Label02:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
;; message d'erreur de fichier trop volumineux
;Label03:
;		pop edx										;; dsempiler edx
;		pop ecx										;; dsempiler ecx
;	ret												;; retourner (sortir de la procdure)
ChargerFichier_Customisee ENDP


ALIGN 16
;
; sauvegarder un fichier sur disque (ncessite comdlg32.lib)
;
; Receptionne :
; rien
;
; Retourne :
; eax = nombre d'octets crits (ou zro, s'il y a une erreur)
;
; syntaxe : SauvegarderFichier_Customise
;
SauvegarderFichier_Customise PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke CreateFile,_Fichier_Information_Selection_.lpstrFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax		;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,ADDR CryFich_Clef_Utilisee,DWORD,ADDR _Fichier_Octets_Ecrits_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_		;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant
		mov eax,_Fichier_Octets_Ecrits_					;; retourne le nombre de bits crits dans eax

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
SauvegarderFichier_Customise ENDP


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ALIGN 16
CrypteurDecrypteur:
; initialisation
		invoke GetCommandLine							;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commandes,eax					;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commandes
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax						;; ) et sauvegarder le pointeur obtenu dans Instance_Application
;		mov Informations_Fenetre.hInstance,eax				;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL						;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boite_Dialogue_Principale,eax			;;	) et sauvegarder le pointeur obtenu dans Instance_Boite_Dialogue_Principale
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance des boites de dialogue
		mov Instance_Boites_Dialogue,eax					;; ) et sauvegarder le pointeur obtenu dans Instance_Boites_Dialogue
		mov esi,OFFSET Instance_Memoire					;;	) obtenir une instance mmoire
		call CreerInstanceMemoire						;;	)
		call InitialiserNombresAleatoires					;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
;		mov eax,_Temoins_Aptitudes_Du_MicroProcesseur_		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
;		mov edx,000000010011b							;; cpuid + fpu + cmov
;		mov edx,000001010011b							;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b							;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx									;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx									;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant						;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
;		invoke ReleaseCapture							;; librer les messages de la souris
;		invoke ShowCursor,Vrai							;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boites_Dialogue,Rsrc_IDD_Insuffisant,0,ADDR GestionnaireMessagesBoitesDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je MicroprocesseurInsuffisant						;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS		;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessages au moment voulu)
		jmp MicroprocesseurBoucleMessages					;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent
;


;
; ici, on va voir si une commande  t dfinie
;
		mov _Fichier_Information_Selection_.lpstrFile,OFFSET _Fichier_Chaine_Chemin_Temporaire_		;; impratif, pour que le pointeur soit dfini
; ici, on va chercher l'emplacement de la 2me commande (la premire tant l'application elle mme...)
		xor eax,eax									;; commencer ds le dpart
		mov esi,OFFSET CryFich_Chaine_Separation_Ligne_Commande		;; placer l'adresse de la chane  trouver
		mov edi,Pointeur_Ligne_Commandes					;; placer l'adresse de la chane  scanner
		call ChercherChaineAscii_Ascendante				;; chercher l'occurence de la sparation des arguments d'une ligne de commande
		test eax,eax									;; fixer les flags de eax
		js PasDeCommandes								;; si c'est sign (pas d'arguments trouv), aller PasDeCommandes
; sinon, ici il va falloir tester s'il faut charger un fichier
		mov esi,Pointeur_Ligne_Commandes					;; placer l'adresse de dpart de la ligne de commande
		add esi,(SIZEOF CryFich_Chaine_Separation_Ligne_Commande)-1		;; ajouter la taille de la chane de sparation des arguments
		add esi,eax									;; ajouter la position trouve
		mov edi,_Fichier_Information_Selection_.lpstrFile		;; placer l'adresse de destination de la chaine dans edi
		call CopierChaineAscii							;; recopier l'argument dans le chemin de la structure
; ici, on s'assure qu'il n'y aura que la 2me commande
		xor eax,eax									;; ) chercher le guillemet de clture de l'argument
		mov esi,OFFSET CryFich_Chaine_Fin_Commande			;; )
		mov edi,_Fichier_Information_Selection_.lpstrFile		;; )
		call ChercherChaineAscii_Ascendante				;; )
		add eax,_Fichier_Information_Selection_.lpstrFile		;; ajouter l'adresse de dpart  la position trouve
		mov BYTE PTR [eax],0							;; remplacer le guillemet par un zro de fin de chane
		mov Pointeur_Temporaire,eax						;; sauvegarder l'adresse de fin de chane
; ici, on s'assure que c'est bien un fichier
		sub eax,_Fichier_Information_Selection_.lpstrFile		;; ) chercher la barre de sparation chemin\fichier
		mov esi,OFFSET Chaine_Separation_Chemin_Nom			;; )
		mov edi,_Fichier_Information_Selection_.lpstrFile		;; )
		call ChercherChaineAscii_Descendante				;; )
; "\" n'as pas t trouv ?
		test eax,eax									;;	) ce n'est donc pas un fichier, du coup on sort
		js PasDeCommandes								;;	)
; ici, c'est un fichier, on recopie le nom du fichier dans la structure
		mov esi,_Fichier_Information_Selection_.lpstrFile		;; ) on recopie le nom du fichier dans la structure
		add esi,(SIZEOF Chaine_Separation_Chemin_Nom)-1		;; )
		add esi,eax									;; )
		mov edi,OFFSET CryFich_Chaine_Nom_Fichier			;; )
		call CopierChaineAscii							;; )
; ici, on teste si c'est un fichier cuk
		mov esi,Pointeur_Temporaire						;; lire l'adresse de fin de chane
		sub esi,4										;; enlever 4 (.cuk)  esi
		mov edi,OFFSET CryFich_Chaine_Extension_Cuk			;; placer l'adresse de l'extension ".cuk" dans edi
		call ComparerChainesAscii_NonSensibleCasse			;; comparer les chanes sans tenir compte de la casse
; eax = -1 si les chanes sont semblables, sinon eax contient la position (l'octet du bloc) o se situe la premire diffrence
		test eax,eax									;; fixer les flags de eax
		js FichierDepartCuk								;; si c'est sign (extension trouve), aller FichierDepartCuk
; ici, on teste si c'est un fichier crypted
		mov esi,Pointeur_Temporaire						;; lire l'adresse de fin de chane
		sub esi,8										;; enlever 8 (.crypted)  esi
		mov edi,OFFSET CryFich_Chaine_Extension_Crypted		;; placer l'adresse de l'extension ".crypted" dans edi
		call ComparerChainesAscii_NonSensibleCasse			;; comparer les chanes sans tenir compte de la casse
; eax = -1 si les chanes sont semblables, sinon eax contient la position (l'octet du bloc) o se situe la premire diffrence
		test eax,eax									;; fixer les flags de eax
		jns CommandesTraitees							;; si ce n'est pas sign, (extension non trouve), aller CommandesTraitees
; ici, il y a bien un fichier crypted  charger... alors on y va...

;
; cas d'un fichier crypted
;
FichierDepartCrypted:
; le charger
		mov esi,OFFSET Instance_Memoire					;; lire l'instance mmoire
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; lire la structure _Bloc_Memoire_ correspondante
		call ChargerFichier_Customisee					;; et charger le fichier dans l'espace rserv 
		mov CryFich_Tampon_Bloc_Fichier._Taille_Du_Bloc_,eax		;; place le nombre d'octets lus dans la taille du bloc mmoire
; ici, le fichier est en mmoire avec sa taille
; et un espace  t rserv : 260 octets (MAX_PATH) ont t rajouts pour rajouter le nom+extension juste aprs,
; ainsi qu'un dword suplmentaire pour la taille du fichier

;; afficher le nom du fichier
;		invoke SetDlgItemText,HWndGM,Rsrc_IDC_Nom_Fichier,ADDR CryFich_Chaine_Nom_Fichier		;; afficher le texte
;; activer le cryptage/dcryptage
;		invoke GetDlgItem,HWndGM,Rsrc_IDC_Crypter_Fichier		;; obtenir les info de l'ID
;		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
;; activer la sauvegarde de fichier
;		invoke GetDlgItem,HWndGM,Rsrc_IDC_Sauver_Fichier		;; obtenir les info de l'ID
;		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
; mettre  jour les tmoins
		bts CryFich_Temoin_Statut_Fichier,0				;; tmoin, comme quoi le fichier est crypt
		bts CryFich_Temoins_Activations,0					;; placer le tmoin de bloc mmoire utilis
		btr CryFich_Temoins_Activations,2					;; activer le bouton de cryptage / dcryptage
		btr CryFich_Temoins_Activations,3					;; activer le bouton de sauvegarde fichier
		jmp CommandesTraitees							;; aller CommandesTraitees
;
; cas d'un fichier cuk
;
FichierDepartCuk:
; charger la clef
		mov esi,OFFSET Instance_Memoire					;; lire l'instance mmoire
		mov edi,OFFSET CryFich_Tampon_Bloc_Clef					;; lire la structure _Bloc_Memoire_ correspondante
		call ChargerFichier								;; et charger le fichier dans l'espace rserv 
; lire la clef
		mov eax,CryFich_Tampon_Bloc_Clef._Pointeur_			;; placer l'adresse de dpart des donnes dans eax
		mov eax,DWORD PTR [eax]							;; placer le dword en eax dans eax
		mov CryFich_Clef_Utilisee,eax						;; sauvegarder la clef
; effacer le bloc mmoire devenu inutile
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour notre tampon clef
		mov edi,OFFSET CryFich_Tampon_Bloc_Clef				;; )
		call SupprimerFichierEnMemoire					;; )
;; mettre  jour l'affichage de la clef
;		mov eax,CryFich_Clef_Utilisee							;; lire la clef
;		mov esi,OFFSET CryFich_Chaine_Clef_Utilisee				;; placer l'adresse de la chaine ascii correspondante dans esi
;;		call ConvertirValeurEnChaineDecimale				;; ) convertir la valeur en eax en chaine ascii
;		call ConvertirValeurEnChaineHexa					;; )
;;		call ConvertirValeurEnChaineHexaPleine				;; )
;		invoke SetDlgItemText,HWndGM,Rsrc_IDC_Valeur_Clef,OFFSET CryFich_Chaine_Clef_Utilisee		;; et mise  jour de la chaine  l'cran
;; activer la sauvegarde de la clef
;		invoke GetDlgItem,HWndGM,Rsrc_IDC_Sauver_Clef		;; obtenir les info de l'ID
;		invoke EnableWindow,eax,TRUE						;; activer le control correspondant
		btr CryFich_Temoins_Activations,4					;; enlever le tmoin de sauvegarde clef
PasDeCommandes:
; placer "aucun" dans la chane qui sera traite en permanence
		mov esi,OFFSET CryFich_Chaine_Nom_Fichier_Depart		;; placer l'adresse source
		mov edi,OFFSET CryFich_Chaine_Nom_Fichier			;; placer l'adresse de destination
		call CopierChaineAscii							;; et copier la chaine
CommandesTraitees:


;
; appeler la boite de dialogue principale
;
		invoke DialogBoxParam,Instance_Boite_Dialogue_Principale,Rsrc_IDD_CryFich_Principal,0,ADDR GestionnaireMessagesBoiteDialogueCrypteurDecrypteur,0


;
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
;
BoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL		;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je FinBoucleMessages							;; si c'est gal  0 (pas de message), aller FinBoucleMessages
;		invoke TranslateMessage,ADDR Informations_Messages_OS		;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS		;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoiteDialogueCrypteurDecrypteur au moment voulu)
		jmp BoucleMessages								;; aller BoucleMessages (pour aller lire le message suivant)
FinBoucleMessages:


;
; vider la mmoire (si un bloc  t cr)
;
		bt CryFich_Temoins_Activations,0					;; tester le temoin pour le bloc mmoire
		jnc EviterViderMemoire							;; si c'est inutilis, aller EviterViderMemoire
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'espace mmoire pour notre tampon fichier
		mov edi,OFFSET CryFich_Tampon_Bloc_Fichier			;; )
		call SupprimerFichierEnMemoire					;; )
EviterViderMemoire:


;
; et par ici la sortie...
;
MicroprocesseurInsuffisant:
		mov esi,OFFSET Instance_Memoire					;; ) supprimer l'intance mmoire
		call SupprimerInstanceMemoire						;; )
		invoke ExitProcess,Informations_Messages_OS.wParam		;; sortie de l'application
;
; fin du programme
;
END CrypteurDecrypteur
