;
; les procdures
;
.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;
_Temoins_Aptitudes_Du_MicroProcesseur_	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =

;_Temoin_Type_Du_MicroProcesseur_		DWORD ?
;
;
;
;
;


.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Syntaxe :
; call DefinirAptitudesDuProcesseur
;
; Retourne :
; eax et la variable _Temoins_Aptitudes_Du_MicroProcesseur_ sont dfinis avec les bits positionns
;
DefinirAptitudesDuProcesseur PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor esi,esi									;; mettre esi (le registre qui stockera les bits)  0
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd										;; ) copier les flags+flags etendus dans eax et edx
		pop eax										;; )
		mov edx,eax									;; )
		btc eax,21									;; inverser le flag ID (bit 21)
		push eax										;; ) et recopier le rsultat dans les flags
		popfd										;; )
		pushfd										;;	) puis on recopie  nouveau les flags dans eax
		pop eax										;;	)
		cmp eax,edx									;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid								;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		bts esi,0										;; positionner le bit correspondant dans esi

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0										;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;													;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1										;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
													;; (eax contient le type, le model,la famille,...)
													;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0										;; tester le bit 0
		jnc PasSupportFpu								;; si le flag carry n'est pas positionn, aller PasSupportFpu
		bts esi,1										;; positionner le bit correspondant dans esi
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4										;; tester le bit 4
		jnc PasSupportRdtsc								;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		bts esi,2										;; positionner le bit correspondant dans esi
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8										;; tester le bit 8
		jnc PasSupportCmpXchg8b							;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		bts esi,3										;; positionner le bit correspondant dans esi
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15										;; tester le bit 15
		jnc PasSupportCmov								;; si le flag carry n'est pas positionn, aller PasSupportCmov
		bts esi,4										;; positionner le bit correspondant dans esi
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19										;; tester le bit 19
		jnc PasSupportClfsh								;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		bts esi,5										;; positionner le bit correspondant dans esi
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23										;; tester le bit 23
		jnc PasSupportMmx								;; si le flag carry n'est pas positionn, aller PasSupportMmx
		bts esi,6										;; positionner le bit correspondant dans esi
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24										;; tester le bit 24
		jnc PasSupportFxsr								;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		bts esi,7										;; positionner le bit correspondant dans esi
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25										;; tester le bit 25
		jnc PasSupportSse								;; si le flag carry n'est pas positionn, aller PasSupportSse
		bts esi,8										;; positionner le bit correspondant dans esi
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26										;; tester le bit 26
		jnc PasSupportSse2								;; si le flag carry n'est pas positionn, aller PasSupportSse2
		bts esi,9										;; positionner le bit correspondant dans esi
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28										;; tester le bit 28
		jnc PasSupportHtt								;; si le flag carry n'est pas positionn, aller PasSupportHtt
		bts esi,10									;; positionner le bit correspondant dans esi
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0										;; tester le bit 0
		jnc PasSupportSse3								;; si le flag carry n'est pas positionn, aller PasSupportSse3
		bts esi,11									;; positionner le bit correspondant dans esi
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx									;; tester le bit 
;		jnc PasSupportXxx								;; si le flag carry n'est pas positionn, aller
;		bts esi,x										;; positionner le bit correspondant dans esi
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2										;; ici, on dtermine les infos concernant le cache
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		mov _Temoins_Aptitudes_Du_MicroProcesseur_,esi		;; sauvegarder les tmoins dans notre variable
		mov eax,esi									;; et les recopier dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


ALIGN 16
;
; positionner une fentre outils  son emplacement logique
;
; Syntaxe :
; mov esi,{pointeur de la fentre}
; mov edi,{OFFSET (adresse) de la structure RECT utilise}
; call PositionnerFenetreOutil
;
; Retourne :
; eax = 0 si erreur
;
; Syntaxe : PositionnerFenetreOutil
;
PositionnerFenetreOutil PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		invoke GetWindowRect,esi,edi						;; obtenir les coordonnes de la boite de dialogue
		mov eax,(RECT PTR [edi]).left						;; ) calculer la largeur et la placer dans (RECT PTR [edi]).right
		sub (RECT PTR [edi]).right,eax					;; )
		mov eax,(RECT PTR [edi]).top						;;	) calculer la hauteur et la placer dans (RECT PTR [edi]).bottom
		sub (RECT PTR [edi]).bottom,eax					;;	)
		invoke GetSystemMetrics,SM_CXSCREEN				;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).right					;; soustraire la largeur de notre ecran final
		mov (RECT PTR [edi]).left,eax						;; placer la nouvelle position x
		add (RECT PTR [edi]).right,eax					;; et ajouter la position x  la taille x
		invoke GetSystemMetrics,SM_CYSCREEN				;; obtenir la taille y de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).bottom					;; soustraire la largeur de notre ecran final
		sar eax,1										;; pour centrer verticalement
		mov (RECT PTR [edi]).top,eax						;; placer la nouvelle position Y
		add (RECT PTR [edi]).bottom,eax					;; et ajouter la position y  la taille y
		invoke GetSystemMetrics,SM_CXVSCROLL				;; ) enlever la largeur d'une barre de scrolling verticale
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke GetSystemMetrics,SM_CXBORDER				;; ) (ici, avec les bordures)
		add eax,eax									;; plus rapide que :
;		shl eax,1										;; 
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke SetWindowPos,esi,NULL,(RECT PTR [edi]).left,(RECT PTR [edi]).top,NULL,NULL,SWP_NOSIZE or SWP_NOZORDER

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner, sortir de la procdure
PositionnerFenetreOutil ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gnration de nombres alatoires
; *
; * note : ici je n'ai pas utilis les valeurs que j'utilise habituellement, parcequ'elles font partie de ma
; * signature (et vous ne voudriez pas vous retrouver avec un procs sur le dos, non ?) alors j'en ai mis d'autres
; * qui devrait fonctionner...
; * si ce n'est pas le cas changez les... le systme employ permet un grand ventail de possibilits
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Nombres_Aleatoires_		DWORD ?


.CODE
ALIGN 16
;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
; Rceptionne :
; rien
;
; Retourne:
; eax = nombre de tick depuis le dmarrage de l'ordi. (mais surtout, la variable _Nombres_Aleatoires_ est dfinie)
;
; syntaxe : InitialiserNombresAleatoires
;
InitialiserNombresAleatoires PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke GetTickCount								;; obtenir les millisecondes depuis le dmarrage
		test eax,eax									;; tester si eax = 0 (si c'est possible ! si vous lancez ce programme 48 jours aprs le dmarrage de l'ordinateur, lol)
		jnz Label1									;; si diffrent aller Label 1
		mov eax,123456789								;; mettre un nombre quelconque (pour eviter une division ultrieure par 0, suivant le gnrateur utilis)
Label1:	mov _Nombres_Aleatoires_,eax						;; sauver le rsultat pour initialiser les nombres alatoires

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
InitialiserNombresAleatoires ENDP


ALIGN 16
;
; generer un nombre aleatoire 32-bits entre 0 et une valeur maximale (exclue)
;
; Rceptionne :
; ebx = la valeur maximale +1 (ne peut pas tre zro, doit imprativement tre suprieur  1 pour une valeur
; situe dans un rang, ou 1 pour gnrer une valeur alatoire 32 bits)
;
; Retourne :
; eax = nombre aleatoire entre 0 et la valeur maximale (exclue), ou un nombre alatoire 32 bits si ebx = 1
;
; syntaxe : GenererNombreAleatoire
;
GenererNombreAleatoire PROC
		push edx										;; empiler edx

		mov eax,987654321								;; placer 987654321 dans eax
		mul _Nombres_Aleatoires_							;; multiplier eax par l'alatoire prcedent
		bswap eax										;; inverser l'ordre des octets pour rendre la valeur plus alatoire
		xor eax,078787878h								;; et pratiquer une inversion de bits (ne peut tre fait avec 0h ou FFFFFFFFh)
		jnz Label1									;; si c'est diffrent de 0, aller Label1
		mov eax,123456789								;; sinon, placer 123456789 dans eax
Label1:	mov _Nombres_Aleatoires_,eax						;; sauvegarder le nouveau nombre alatoire pour la gnration du prochain
; ici, on teste si c'est le cas d'une valeur alatoire 32 bits 
		cmp ebx,1										;; comparer ebx  1
		je Label2										;; si c'est le cas, c'est une valeur alatoire 32 bits, alors aller Label2
; ici, on traite le cas d'une valeur comprise entre 0 et X-1
		mul ebx										;; multiplier ensuite le nombre alatoire par la valeur maximale
		mov eax,edx									;; et placer le dpassement en eax
Label2:
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
GenererNombreAleatoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine de cryptage/dcryptage
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


.CODE
ALIGN 16
;
; crypter/dcrypter un bloc mmoire (note : les routines concernant la gnration de nombres pseudo alatoires
; doivent tre actives pour l'utilisation de cette procdure...)
;
; Rceptionne :
; eax = clef de cryptage/dcryptage
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; Retourne :
; rien
;
; syntaxe : CrypterDecrypterBlocMemoire
;
CrypterDecrypterBlocMemoire PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov esi,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_		;; placer la taille du bloc mmoire dans esi
		mov edi,(_Bloc_Memoire_ PTR [edi])._Pointeur_		;; placer l'adresse de dpart du bloc mmoire dans edi
		mov _Nombres_Aleatoires_,eax						;; placer galement cette valeur dans _Nombres_Aleatoires_ pour pouvoir gnrer la bonne suite
		mov ebx,1										;; placer 1 dans ebx (pour gnrer des valeurs alatoires 32 bits)
		mov ecx,esi									;; placer la taille du bloc mmoire dans ecx
; ici, on traite les dwords
		and ecx,011111111111111111111111111111100b			;; ne conserver que les dwords
		jz Label02									;; si ecx est gal  0, aller Label02
		add edi,ecx									;; ajouter la taille  l'adresse en edi
		neg ecx										;; inverser ecx qui devient notre compteur
; ici, c'est la boucle qui va traiter le bloc mmoire
Label01:	call GenererNombreAleatoire						;; gnrer un nombre pseudo alatoire
		xor DWORD PTR [edi+ecx],eax						;; inverser les bits du dword en edi+ecx en utilisant le masque en eax
		add ecx,DWORD									;;
		jnz Label01									;; tant que c'est diffrent de 0, aller Label01
; ici, on traite les octets
Label02:	mov ecx,esi									;; placer la taille du bloc mmoire dans ecx
		and ecx,000000000000000000000000000000011b			;; ne conserver que les octets
		jz Label05									;; si ecx est gal  0, aller Label05
		add edi,ecx									;; ajouter la taille  l'adresse en edi
		neg ecx										;; inverser ecx qui devient notre compteur
		call GenererNombreAleatoire						;; gnrer un nombre pseudo alatoire
		cmp ecx,-1									;; comparer ecx  -1
		je Label04									;; si c'est le cas, aller Label04
		cmp ecx,-2									;; comparer ecx  -2
		je Label03									;; si c'est le cas, aller Label03
		mov edx,eax									;; copier eax dans edx
		shr edx,8										;; dcaler edx de 8 bits  droite (pour passer  l'octet suivant)
		xor BYTE PTR [edi+ecx+3],dl						;; inverser les bits du dword en edi+ecx+3 en utilisant le masque en eax
Label03:	mov edx,eax									;; copier eax dans edx
		shr edx,16									;; dcaler edx de 16 bits  droite (pour passer  l'octet suivant)
		xor BYTE PTR [edi+ecx+2],dl						;; inverser les bits du dword en edi+ecx+2 en utilisant le masque en eax
Label04:	mov edx,eax									;; copier eax dans edx
		shr edx,24									;; dcaler edx de 24 bits  droite (pour passer  l'octet suivant)
		xor BYTE PTR [edi+ecx+1],dl						;; inverser les bits du dword en edi+ecx+1 en utilisant le masque en eax
Label05:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
CrypterDecrypterBlocMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement/gestion de bloc mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
_Decalage_Bloc_Memoire_Temporaire_		_Bloc_Memoire_ <?>


.CODE
ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = taille du bloc mmoire que l'on va crer (en octets)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; eax = adresse du bloc mmoire alig
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_ et x._Taille_Du_Bloc_ sont dfinies
;
; syntaxe : AllouerBlocMemoire
;
AllouerBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; copier un bloc memoire vers un autre bloc memoire (c'est une version de CopierBlocMemoire qui tiens compte des possibles chevauchements) 30% plus rapide que RtlMoveMemory
;
; Rceptionne :
; eax = taille  bouger/copier en octets
; esi = adresse du bloc source
; edi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : BougerBlocMemoire
;
BougerBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; test de chevauchement
		cmp esi,edi									;; comparer l'adresse source  l'adresse destination
		jae Label00									;; si c'est suprieur ou gal, aller Label00
		mov ecx,edi									;; placer l'adresse destination dans ecx
		sub ecx,esi									;; soustraire l'adresse source  ecx
		cmp eax,ecx									;; comparer eax (la taille)  ecx (la taille obtenue entre source et destination)
		ja Label07									;; si c'est suprieur ou gal (un chevauchement est possible), aller Label07

; ici on traite les owords
Label00:	mov ecx,eax									;; copier eax dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label02									;; si ecx est gal  0, aller Label02
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
;		nop											;; ) l'alignement n'est pas ncessaire pour un meilleur rendement
;		nop											;; )
Label01:	mov edx,DWORD PTR[esi+ecx]						;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR[edi+ecx],edx						;; placer le dword en edi+ecx
		mov edx,DWORD PTR[esi+ecx+4]						;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR[edi+ecx+4],edx						;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR[esi+ecx+8]						;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR[edi+ecx+8],edx						;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR[esi+ecx+12]						;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR[edi+ecx+12],edx						;; placer le dword en edi+ecx+12
		add ecx,16									;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label01									;; tant que ecx est diffrent de 0, aller Label01

; ici on traite les dwords
Label02:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label04									;; si ecx est gal  0, aller Label04
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label03:	mov edx,DWORD PTR [esi+ecx]						;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx						;; et le recopier en edi+ecx
		add ecx,4										;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label03									;; tant que ecx est diffrent de 0, aller Label03

; ici on traite les octets
Label04:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label06									;; si ecx est gal  0, aller Label06
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label05:	mov dl,BYTE PTR [esi+ecx]						;; placer l'octet en esi+edx dans dl
		mov BYTE PTR [edi+ecx],dl						;; et le recopier en edi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label05									;; tant que ecx est diffrent de 0, aller Label05
Label06:	sub esi,eax									;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)

ALIGN 16
; ici, les blocs se chevauchent
Label07:	add esi,eax									;; on ajoute eax  esi
		add edi,eax									;; et aussi  edi, (parcequ'on va commencer par la fin des blocs)

; ici on traite les octets
		mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label09									;; si ecx est gal  0, aller Label09
		sub esi,ecx									;; on enleve ecx  esi
		sub edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
Label08:	dec ecx										;; on enleve 1  ecx (notre pas de boucle)
		mov dl,BYTE PTR [esi+ecx]						;; placer l'octet en esi+edx dans dl
		mov BYTE PTR [edi+ecx],dl						;; et le recopier en edi+ecx
		jnz Label08									;; tant que ecx est diffrent de 0, aller Label08

; ici on traite les dwords
Label09:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label11									;; si ecx est gal  0, aller Label11
		sub esi,ecx									;; on enleve ecx  esi
		sub edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
Label10:	add ecx,-4									;; on enleve 4  ecx (notre pas de boucle)
		mov edx,DWORD PTR [esi+ecx]						;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx						;; et le recopier en edi+ecx
		jnz Label10									;; tant que ecx est sign, aller Label10

; ici on traite les owords
Label11:	mov ecx,eax									;; copier eax dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label13									;; si ecx est gal  0, aller Label13
		sub esi,ecx									;; on ajoute ecx  esi
		sub edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		nop											;; alignement ncessaire pour un meilleur rendement
Label12:	add ecx,-16									;; on enleve 16  ecx (notre pas de boucle)
		mov edx,DWORD PTR[esi+ecx+12]						;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR[edi+ecx+12],edx						;; placer le dword en edi+ecx+12
		mov edx,DWORD PTR[esi+ecx+8]						;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR[edi+ecx+8],edx						;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR[esi+ecx+4]						;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR[edi+ecx+4],edx						;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR[esi+ecx]						;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR[edi+ecx],edx						;; placer le dword en edi+ecx
		jnz Label12									;; tant que ecx est diffrent de 0, aller Label12
Label13:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
BougerBlocMemoire ENDP


ALIGN 16
;
; copier un bloc memoire vers un autre bloc memoire
; note : il faut s'assurer que les blocs mmoire ne se chevauchent pas, sinon il faut utiliser BougerBlocMemoire...
;
; Rceptionne :
; eax = taille  copier en octets
; esi = adresse du bloc source
; edi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : CopierBlocMemoire
;
CopierBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; ici on traite les owords
		mov ecx,eax									;; copier eax dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label1										;; si ecx est gal  0, aller Label1
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
Label0:	mov edx,DWORD PTR[esi+ecx]						;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR[edi+ecx],edx						;; placer le dword en edi+ecx
		mov edx,DWORD PTR[esi+ecx+4]						;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR[edi+ecx+4],edx						;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR[esi+ecx+8]						;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR[edi+ecx+8],edx						;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR[esi+ecx+12]						;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR[edi+ecx+12],edx						;; placer le dword en edi+ecx+12
		add ecx,16									;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label0									;; tant que ecx est diffrent de 0, aller Label0

; ici on traite les dwords
Label1:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
		nop											;; alignement ncessaire pour un meilleur rendement
Label2:	mov edx,DWORD PTR [esi+ecx]						;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx						;; et le recopier en edi+ecx
		add ecx,4										;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est sign, aller Label2

; ici on traite les octets
Label3:	mov ecx,eax									;; copier eax dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add esi,ecx									;; on ajoute ecx  esi
		add edi,ecx									;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx										;; inverser ecx
Label4:	mov dl,BYTE PTR [esi+ecx]						;; placer l'octet en esi+edx dans dl
		mov BYTE PTR [edi+ecx],dl						;; et le recopier en edi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
Label5:	sub esi,eax									;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierBlocMemoire ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; eax = l'adresse de l'instance
; et les variables x._Instance_, x._Taille_Initiale_ et x._Taille_Maximale_ sont dfinies
;
; syntaxe : CreerInstanceMemoire
;
CreerInstanceMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_		;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax		;; sauvegarde du pointeur de l'instance

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; dcaler (de x octets) un bloc mmoire
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
; et le dcalage se fait sur la gauche, c'est un parti pris que j'assume...
;
; Rceptionne :
; eax = pas (nombre d'octets) de dcalage
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_, qui concerne le bloc mmoire  dcaler
;
; Retourne :
; rien
;
; syntaxe : DecalerBlocMemoire
;
DecalerBlocMemoire PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,esi									;; copier esi dans ebx (ca va reservir aprs...)
		mov ebp,edi									;; copier edi dans ebp (parcequ'on va utiliser edi maintenant)
; premirement on alloue un bloc mmoire correspondant au nomdre d'octets de dcalage (ce sera la partie sauvegarde)
;		mov eax,										;; (inutile, c'est dja bon)
;		mov esi,OFFSET									;; (inutile, c'est dja bon)
		mov edi,OFFSET _Decalage_Bloc_Memoire_Temporaire_		;; placer l'adresse du bloc mmoire temporaire dans edi
		call AllouerBlocMemoire							;; et allouer le bloc

; ensuite, on copie le dcalage dans le bloc mmoire que l'on vient de crer
		mov eax,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_		;; placer le pas de dcalage dans eax (parceque eax  t modifi)
		mov esi,(_Bloc_Memoire_ PTR [ebp])._Pointeur_		;; copier l'adresse du bloc  dcaler dans esi
		mov edi,(_Bloc_Memoire_ PTR [edi])._Pointeur_		;; placer l'adresse de la sauvegarde dans edi
		call CopierBlocMemoire							;; copier le bloc

; puis, on dplace la partie  bouger
;		mov esi,(_Bloc_Memoire_ PTR [ebp])._Pointeur_		;; (inutile, c'est dja bon)
		add esi,eax									;; placer l'adresse de dpart de la partie  bouger dans esi
		mov edi,(_Bloc_Memoire_ PTR [ebp])._Pointeur_		;; copier l'adresse de dbut du bloc  dcaler dans edi
		mov ecx,eax									;; copier la valeur de dcalage dans ecx
		mov eax,(_Bloc_Memoire_ PTR [ebp])._Taille_Du_Bloc_		;; placer la taille originelle du bloc mmoire  dcaler dans eax
		sub eax,ecx									;; enlever  cette taille la valeur de dcalage
		call BougerBlocMemoire							;; bouger le bloc

; puis, on remet la partie sauvegarde au nouvel emplacement
		add edi,eax									;; ajouter (taille du bloc - pas de dcalage)  l'adresse de dbut du bloc  dcaler
		mov esi,_Decalage_Bloc_Memoire_Temporaire_._Pointeur_		;; placer l'adresse de la sauvegarde dans esi
		mov eax,_Decalage_Bloc_Memoire_Temporaire_._Taille_Du_Bloc_		;; placer le pas de dcalage dans eax
		call CopierBlocMemoire							;; copier le bloc

; enfin, on libre le bloc mmoire utilis pour la sauvegarde (puisqu'on n'en a plus besoin maintenant)
		mov esi,ebx									;; placer l'adresse de la structure _Informations_Memoire_ dans esi
		mov edi,OFFSET _Decalage_Bloc_Memoire_Temporaire_		;; placer l'adresse du bloc mmoire temporaire dans edi
		call LibererBlocMemoire							;; librer le bloc

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
DecalerBlocMemoire ENDP


ALIGN 16
;
; effacer un bloc memoire (en le remplissant de 0)
;
; Rceptionne :
; eax = taille  ffacer en octets
; esi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : EffacerBlocMemoire
;
EffacerBlocMemoire PROC
		push ecx										;; empiler ecx

; ici on traite les owords
		mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label1										;; si ecx est gal  0, aller Label1
		add esi,ecx									;; on ajoute ecx  esi
		neg ecx										;; inverser ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
Label0:	mov DWORD PTR[esi+ecx],0							;; placer 0 en esi+ecx
		mov DWORD PTR[esi+ecx+4],0						;; placer 0 en esi+ecx+4
		mov DWORD PTR[esi+ecx+8],0						;; placer 0 en esi+ecx+8
		mov DWORD PTR[esi+ecx+12],0						;; placer 0 en esi+ecx+12
		add ecx,16									;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label0									;; tant que ecx est diffrent de 0, aller Label0

; ici on traite les dwords
Label1:	mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
		add esi,ecx									;; on ajoute ecx  esi
		neg ecx										;; inverser ecx
Label2:	mov DWORD PTR [esi+ecx],0						;; placer 0 en esi+ecx
		add ecx,4										;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est sign, aller Label2

; ici on traite les octets
Label3:	mov ecx,eax									;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add esi,ecx									;; on ajoute ecx  esi
		neg ecx										;; inverser ecx
Label4:	mov BYTE PTR [esi+ecx],0							;; placer 0 en esi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
Label5:	sub esi,eax									;; soustraire la taille  esi (pour retrouver l'adresse originelle)

		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
EffacerBlocMemoire ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;

; retourne :
; rien
;
; syntaxe : LibererBlocMemoire
;
LibererBlocMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_		;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
LibererBlocMemoire ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerInstanceMemoire
;
SupprimerInstanceMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_		;; librer l'instance mmoire

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gestion de fichier
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Fichier_Octets_Lus_					DWORD ?
_Fichier_Pointeur_Fichier_Temporaire_		DWORD ?
_Fichier_Octets_Ecrits_					DWORD ?

_Fichier_Chaine_Chemin_Temporaire_	BYTE MAX_PATH dup (?)			;; MAX_PATH = 260
_Fichier_Chaine_Chemin_Temporaire_Ajout	BYTE "\Fichier",0

ALIGN 16
_Fichier_Information_Selection_ OPENFILENAME <?>
;OPENFILENAME STRUCT
;	lStructSize		DWORD ?							;; taille de la structure (en octets)
;	hwndOwner			DWORD ?							;; intance de la fentre (HWnd)
;	hInstance			DWORD ?							;; intance d'une fenetre personalise (le flag OFN_ENABLETEMPLATEHANDLE doit tre slectionn)
;	lpstrFilter		DWORD ?							;; pointeur contenant une paire de filtre
;	lpstrCustomFilter	DWORD ?							;; pointeur contenant une paire de filtre personnalis (ignor si = 0)
;	nMaxCustFilter		DWORD ?							;; taille en octets des filtres personnalis (ignor si = 0)
;	nFilterIndex		DWORD ?							;; n du filtre par dfaut (le numro est fonction de l'ordre des filtres)
;	lpstrFile			DWORD ?							;; pointeur d'une chane (drive/chemin/fichier.extension)
;	nMaxFile			DWORD ?							;; taille maximale en octets de la chane (drive/chemin/fichier.extension)
;	lpstrFileTitle		DWORD ?							;; pointeur d'une chane (fichier.extension)
;	nMaxFileTitle		DWORD ?							;; taille maximale en octets de la chane (fichier.extension) (ignor si = 0)
;	lpstrInitialDir	DWORD ?							;; pointeur sur la chane (drive/chemin) (ou rpertoire actuel si = 0)
;	lpstrTitle		DWORD ?							;; pointeur de la chane qui apparaitra comme titre dans la barre de la boite de dialogue
;	Flags			DWORD ?							;; flags d'initialisation de la boite de dialogue
;	nFileOffset		WORD ?							;; position o se situe le nom du fichier dans la chane (drive/chemin/fichier.extension)
;	nFileExtension		WORD ?							;; position o se situe l'extension dans la chane (drive/chemin/fichier.extension)
;	lpstrDefExt		DWORD ?							;; pointeur d'une chane extension (sans le point) par dfaut qui sera appliqu si l'utilisateur n'en entre pas (ignor si = 0)
;	lCustData			DWORD ?							;; (ignor si lpfnHook est inactif)
;	lpfnHook			DWORD ?							;; (ignor si OFN_ENABLEHOOK n'est pas slectionn)
;	lpTemplateName		DWORD ?							;; (ignor si OFN_ENABLETEMPLATE n'est pas slectionn)
;OPENFILENAME ENDS

ALIGN 16
_Fichier_Information_Fichier_ WIN32_FIND_DATA <?>
;WIN32_FIND_DATA STRUCT
;	dwFileAttributes	DWORD ?							;; attributs du fichier ou du rpertoire
;; (FILE_ATTRIBUTE_ARCHIVE, FILE_ATTRIBUTE_COMPRESSED, FILE_ATTRIBUTE_DIRECTORY, FILE_ATTRIBUTE_HIDDEN,
;; FILE_ATTRIBUTE_NORMAL, FILE_ATTRIBUTE_OFFLINE, FILE_ATTRIBUTE_READONLY, FILE_ATTRIBUTE_SYSTEM, FILE_ATTRIBUTE_TEMPORARY)
;	ftCreationTime		FILETIME <?>						;; date concernant la cration du fichier
;	ftLastAccessTime	FILETIME <?>						;; date concernant le dernier accs au fichier
;	ftLastWriteTime	FILETIME <?>						;; date concernant la dernire modification du fichier
;	nFileSizeHigh		DWORD ?							;; ) taille du fichier
;	nFileSizeLow		DWORD ?							;; )
;	dwReserved0		DWORD ?							;;	) inutiliss pour le moment
;	dwReserved1		DWORD ?							;;	)
;	cFileName			BYTE MAX_PATH dup (?)				;; nom du fichier
;	cAlternateFileName	BYTE 14 dup (?)					;; nom coup dos (8+3) du fichier (ou 0 si cFileName est dj compatible dos)
;WIN32_FIND_DATA ENDS

;FILETIME STRUCT
;	dwLowDateTime		DWORD ?							;; ) valeur 64 bits reprsentant le nombre d'intervales
;	dwHighDateTime		DWORD ?							;; ) de 100 nanosecondes, depuis le 1er janvier 1601
;FILETIME ENDS


.CODE
ALIGN 16
;
; charger un fichier compress en mmoire (dans un bloc de mme taille) (ncessite comdlg32.lib)
;
; Receptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_ qui a t prcdemment cre pour recevoir le fichier
;
; Retourne :
; eax = nombre d'octets lus (ou zro s'il y a une erreur, ou -1 si impossible d'obtenir l'info concernant la taille)
;
; syntaxe : ChargerFichier
;
ChargerFichier PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; dfinir les flags de lecture
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ;or OFN_HIDEREADONLY
; obtenir la taille (en octets) du fichier
		invoke FindFirstFile,_Fichier_Information_Selection_.lpstrFile,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE						;; comparer eax  -1
		je Label02									;; si c'est gal (erreur pointeur), aller Label02
; sinon, le pointeur est valide
		invoke FindClose,eax							;; alors, supprimer le pointeur dont on n'a plus besion
;		cmp _Fichier_Information_Fichier_.nFileSizeHigh,0		;; ) fichier trop volumineux ?
;		jne Label03									;; )
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow		;; sinon, rcuprer la taille du fichier
; definir la taille du bloc mmoire ncessaire pour charger le fichier
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer cette taille dans x._Taille_Du_Bloc_
		add eax,000000011h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets) et 1 (pour tre sr d'avoir 1 octet pour un zro final)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_
; lire le fichier
		invoke CreateFile,_Fichier_Information_Selection_.lpstrFile,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax		;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke ReadFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Lus_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_		;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant
		mov eax,_Fichier_Octets_Lus_						;; retourne le nombre d'octets lus dans eax

Label02:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
;; message d'erreur de fichier trop volumineux
;Label03:
;		pop edx										;; dsempiler edx
;		pop ecx										;; dsempiler ecx
;	ret												;; retourner (sortir de la procdure)
ChargerFichier ENDP


ALIGN 16
;
; dfinir la slection du fichier (en dfinissant les adresses : du titre de la fentre, du nom du fichier,
; des filtres utiliss, etc...)
;
; Receptionne :
; eax = instance de la fentre (HWnd/HWndDlg/etc...)
; ebx = adresse (offset) de la chaine du titre de slection
; ecx = adresse (offset) de la chaine du nom (a recevoir, ou  dfinir)
; edx = adresse (offset) de la chaine des filtres de slection
; esi = adresse (offset) de la chaine de l'extension (sans le point) par dfaut
;
; Retourne :
; rien
;
; syntaxe : DefinirTypeFichier
;
DefinirTypeFichier PROC

		mov _Fichier_Information_Selection_.hWndOwner,eax				;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ebx			;; titre de la boite de dialogue
		mov _Fichier_Information_Selection_.lpstrFileTitle,ecx			;; dfini par les fonctions Open et Close
		mov _Fichier_Information_Selection_.lpstrFilter,edx			;; filtres utilis
		mov _Fichier_Information_Selection_.lpstrDefExt,esi			;; l'extension par dfaut
		mov _Fichier_Information_Selection_.lStructSize,SIZEOF OPENFILENAME		;; taille de la structure
		mov _Fichier_Information_Selection_.lpstrFile,OFFSET _Fichier_Chaine_Chemin_Temporaire_		;; adresse de la chaine chemin+nom de rception
		mov _Fichier_Information_Selection_.nMaxFile,MAX_PATH
		mov _Fichier_Information_Selection_.nMaxFileTitle,MAX_PATH
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ; or OFN_HIDEREADONLY



	ret												;; retourner (sortir de la procdure)
DefinirTypeFichier ENDP


ALIGN 16
;
; effacer fichier occupant la mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) de la structure _Bloc_Memoire_ qui est utilise pour le fichier
;
; Retourne :
; rien
;
; syntaxe : SupprimerFichierEnMemoire
;
SupprimerFichierEnMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_		;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerFichierEnMemoire ENDP


ALIGN 16
;
; initialiser la selection de fichier (en dfinissant les adresses : du titre de la fentre, du chemin du fichier,
; du nom du fichier, des filtres utiliss, etc... doit tre utilis une fois, ensuite on utilise DefinirTypeFichier)
;
; eax = instance de l'application
; ebx = instance de la fentre (HWnd/HWndDlg/etc...)
; ecx = adresse (offset) de la chaine du titre de slection par dfaut
; edx = adresse (offset) de la chaine du nom du fichier (a recevoir, ou  dfinir)
; esi = adresse (offset) de la chaine des filtres de slection par dfaut
;
;; edx = adresse (offset) de la chaine du chemin du fichier (a recevoir, ou  dfinir)

;

; Retourne :
; rien
;
; syntaxe : InitialiserSelectionFichier
;
InitialiserSelectionFichier PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov _Fichier_Information_Selection_.hInstance,eax				;; instance de l'application
		mov _Fichier_Information_Selection_.hWndOwner,ebx				;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ecx
		mov _Fichier_Information_Selection_.lpstrFileTitle,edx			;; dfini par les fonctions Open et Close
		mov _Fichier_Information_Selection_.lpstrFilter,esi			;; filtre utilis
		mov _Fichier_Information_Selection_.lStructSize,SIZEOF OPENFILENAME		;; taille de la structure
		mov _Fichier_Information_Selection_.lpstrFile,OFFSET _Fichier_Chaine_Chemin_Temporaire_		;; dfini par les fonctions Open et Close
		mov _Fichier_Information_Selection_.nMaxFile,MAX_PATH
		mov _Fichier_Information_Selection_.nMaxFileTitle,MAX_PATH
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ; or OFN_HIDEREADONLY
		mov _Fichier_Information_Selection_.lpstrCustomFilter,0
		mov _Fichier_Information_Selection_.nMaxCustFilter,0
		mov _Fichier_Information_Selection_.nFilterIndex,0
		mov _Fichier_Information_Selection_.lpstrInitialDir,0
		mov _Fichier_Information_Selection_.nFileOffset,0
		mov _Fichier_Information_Selection_.nFileExtension,0
		mov _Fichier_Information_Selection_.lpstrDefExt,0				;; l'extension par dfaut
		mov _Fichier_Information_Selection_.lCustData,0
		mov _Fichier_Information_Selection_.lpfnHook,0
		mov _Fichier_Information_Selection_.lpTemplateName,0
		invoke GetCurrentDirectory,MAX_PATH,ADDR _Fichier_Chaine_Chemin_Temporaire_
		mov esi,OFFSET _Fichier_Chaine_Chemin_Temporaire_Ajout
		mov edi,OFFSET _Fichier_Chaine_Chemin_Temporaire_
		call FusionnerChainesAscii

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
InitialiserSelectionFichier ENDP


ALIGN 16
;
; obtenir le nom du fichier  charger en mmoire
;
; Receptionne :
; eax = instance de la fentre (HWnd/HWndDlg/etc...)
; ebx = adresse (offset) de la chaine du titre de slection
; ecx = adresse (offset) de la chaine du nom (a recevoir, ou  dfinir)
; edx = adresse (offset) de la chaine des filtres de slection
; esi = adresse (offset) de la chaine de l'extension (sans le point) par dfaut
;
; Retourne :
; eax = zro si aucun fichier n'est slectionn, ou s'il y a une erreur
;
; syntaxe : ObtenirNomFichierACharger
;
ObtenirNomFichierACharger PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov _Fichier_Information_Selection_.hWndOwner,eax				;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ebx			;; adresse de la chaine du titre de la fentre de slection
		mov _Fichier_Information_Selection_.lpstrFileTitle,ecx			;; adresse de la chaine du nom du fichier  obtenir, dfini par la fonction
		mov _Fichier_Information_Selection_.lpstrFilter,edx			;; adresse des chaines de filtre de slection
		mov _Fichier_Information_Selection_.lpstrDefExt,esi			;; adresse de la chane de l'extension par dfaut
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ;or OFN_HIDEREADONLY
		invoke GetOpenFileName,ADDR _Fichier_Information_Selection_		;; obtenir le nom

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
ObtenirNomFichierACharger ENDP


ALIGN 16
;
; obtenir le nom du fichier  sauvegarder
;
; Receptionne :
; eax = instance de la fentre (HWnd/HWndDlg/etc...)
; ebx = adresse (offset) de la chaine du titre de slection
; ecx = adresse (offset) de la chaine du nom (a recevoir, ou  dfinir)
; edx = adresse (offset) de la chaine des filtres de slection
; esi = adresse (offset) de la chaine de l'extension (sans le point) par dfaut
;
; Retourne :
; eax = zro si aucun fichier n'est slectionn, ou s'il y a une erreur
;
; syntaxe : ObtenirNomFichierACharger
;
ObtenirNomFichierASauvegarder PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov _Fichier_Information_Selection_.hWndOwner,eax				;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ebx			;; adresse de la chaine du titre de la fentre de slection
		mov _Fichier_Information_Selection_.lpstrFileTitle,ecx			;; adresse de la chaine du nom du fichier, doit avoir t dfini auparavant
		mov _Fichier_Information_Selection_.lpstrFilter,edx			;; adresse de la chaine du nom du fichier  obtenir, dfini par la fonction
		mov _Fichier_Information_Selection_.lpstrDefExt,esi			;; adresse de la chane de l'extension par dfaut
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ;or OFN_HIDEREADONLY
		invoke GetSaveFileName,ADDR _Fichier_Information_Selection_		;; obtenir le nom

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
ObtenirNomFichierASauvegarder ENDP


ALIGN 16
;
; obtenir la taille non-dcompresse (en octets) du fichier trait prcdemment (dont les variables de
; _Fichier_Information_Selection_ ont t mises  jour)
;
; Rceptionne :
; rien, mais les informations on dus tre dfinis au pralable dans les variables de _Fichier_Information_Selection_
;
; Retourne :
; eax = la taille (non dcomprsse) du fichier, ou -1 si il y a une erreur
;
; syntaxe : ObtenirTailleFichier
;
ObtenirTailleFichier PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke FindFirstFile,_Fichier_Information_Selection_.lpstrFile,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE						;; comparer eax  -1
		je Label02									;; si c'est gal (erreur pointeur), aller Label02
; sinon, le pointeur est valide
		invoke FindClose,eax							;; alors, supprimer le pointeur dont on n'a plus besion
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow		;; et rcuprer la taille du fichier
Label02:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
ObtenirTailleFichier ENDP


ALIGN 16
;
; sauvegarder un fichier sur disque (ncessite comdlg32.lib)
;
; Receptionne :
; edi = adresse (offset) de la structure _Bloc_Memoire_ qui est utilise pour le fichier
;
; Retourne :
; eax = nombre d'octets crits (ou zro, s'il y a une erreur)
;
; syntaxe : SauvegarderFichier
;
SauvegarderFichier PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke CreateFile,_Fichier_Information_Selection_.lpstrFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax		;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Ecrits_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_		;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant
		mov eax,_Fichier_Octets_Ecrits_					;; retourne le nombre de bits crits dans eax

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
SauvegarderFichier ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de conversion valeur -> chaine de caractre dcimale
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
;
; tables pour obtenir les caractres quivalents minuscules/majuscules (fait 1 ko)
; (cette table est francise pour les accents, cdilles, etc...)
;
_ChChAs_NSC_	BYTE 000,001,002,003,004,005,006,007,008,009,010,011,012,013,014,015
			BYTE 016,017,018,019,020,021,022,023,024,025,026,027,028,029,030,031
			BYTE 032,033,034,035,036,037,038,039,040,041,042,043,044,045,046,047
			BYTE 048,049,050,051,052,053,054,055,056,057,058,059,060,061,062,063
			BYTE 064,097,098,099,100,101,102,103,104,105,106,107,108,109,110,111
			BYTE 112,113,114,115,116,117,118,119,120,121,122,091,092,093,094,095
			BYTE 096,065,066,067,068,069,070,071,072,073,074,075,076,077,078,079
			BYTE 080,081,082,083,084,085,086,087,088,089,090,123,124,125,126,127
			BYTE 135,085,069,065,065,065,065,067,069,069,069,073,073,073,132,134
			BYTE 130,146,145,079,079,079,085,085,089,148,129,155,156,156,158,159
			BYTE 065,073,079,085,165,164,166,167,168,169,170,171,172,173,173,175
			BYTE 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
			BYTE 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
			BYTE 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
			BYTE 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
			BYTE 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255


.CODE
ALIGN 16
;
; trouver une chaine de caractres dans une chane/un texte ascii (la premire occurrence)
;
; Rceptionne :
; eax = position de dpart dans la chane
; esi = adresse de la chaine  trouver
; edi = adresse de la chaine/du texte  tester
;
; Retourne :
; eax = -1 si la chane de caractres n'est pas trouve, sinon eax contient la position o se situe cette chane
;
; syntaxe : ChercherChaineAscii_Ascendante
;
ChercherChaineAscii_Ascendante PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		add eax,edi									;; on ajoute la position  l'adresse de la chane
; on stocke le premier octet  trouver
		mov dh,BYTE PTR [esi]							;; placer le premier octet  trouver dans dh
		dec eax										;; enlever 1  l'adresse ( cause de la ligne qui suit...)
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )

; maintenant, recherche du premier caractre identique
Label1:	inc eax										;; augmenter l'adresse de loctet  comparer
		mov dl,BYTE PTR [eax]							;; lire l'octet  comparer, et le placer dans dl
		test dl,dl									;; fixer les flags de dl
		jz Label4										;; si c'est gal  0, aller Label4
		cmp dh,dl										;; sinon, comparer l'octet lu  celui en dh
		jne Label1									;; si c'est diffrent, on continu la recherche, aller Label1

; sinon, on teste les caractres suivants 
		xor ecx,ecx									;; effacer ecx
Label2:	inc ecx										;; augmenter ecx d'1
		mov dl,BYTE PTR [esi+ecx]						;; placer l'octet suivant dans dl
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		cmp dl,BYTE PTR [eax+ecx]						;; et le comparer  l'octet suivant  comparer
		je Label2										;; si c'est gal  0, aller Label2
		jmp Label1									;; aller Label1

; ici la chane est trouve, alors on defini eax qui contiendra l'adresse 
Label3:	sub eax,edi									;; on soustrait l'adresse de la chane pour obtenir la position trouve dans la chane
		jmp Label5									;; aller Label5
Label4:	mov eax,-1									;; sinon on met -1 (chane non trouve dans eax)
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
ChercherChaineAscii_Ascendante ENDP


ALIGN 16
;
; trouver une chaine de caractres dans une chane/un texte ascii (la premire occurrence)
;
; Rceptionne :
; eax = position de dpart dans la chane
; esi = adresse de la chaine  trouver
; edi = adresse de la chaine/du texte  tester
;
; Retourne :
; eax = -1 si la chane de caractres n'est pas trouve, sinon eax contient la position o se situe cette chane
;
; syntaxe : ChercherChaineAscii_NonSensibleCasse_Ascendante
;
ChercherChaineAscii_NonSensibleCasse_Ascendante PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		add eax,edi									;; on ajoute la position  l'adresse de la chane
; on stocke le premier octet  trouver
		movzx ebx,BYTE PTR [esi]							;; placer le premier octet  trouver dans bl
		mov bh,BYTE PTR [_ChChAs_NSC_+ebx]					;; placer l'quivalence de la table dans bh
		dec eax										;; enlever 1  l'adresse ( cause de la ligne qui suit...)

; maintenant, recherche du premier caractre identique
Label1:	inc eax										;; ajouter 1  l'adresse de loctet  comparer
		mov dl,BYTE PTR [eax]							;; lire l'octet  comparer, et le placer dans dl
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si c'est gal  0, aller Label5
		cmp dl,bl										;; sinon, comparer l'octet lu  celui en bl
		je Label2										;; si c'est gal, on va tester les caractres suivant, aller Label2
		cmp dl,bh										;; comparer ensuite  l'quivalence dans la table
		jne Label1									;; si c'est diffrent, on continu la recherche, aller Label1

; sinon, on teste les caractres suivants 
Label2:	xor ecx,ecx									;; effacer ecx
Label3:	inc ecx										;; augmenter ecx d'1
		movzx edx,BYTE PTR [esi+ecx]						;; placer l'octet suivant dans dl
		mov dh,BYTE PTR [_ChChAs_NSC_+edx]					;; placer l'quivalence de la table dans dh
		test dl,dl									;; fixer les flags de dl
		jz Label4										;; si c'est gal  0, aller Label4
		cmp dl,BYTE PTR [eax+ecx]						;; et le comparer  l'octet suivant  comparer
		je Label3										;; si c'est gal  0, aller Label3
		cmp dh,BYTE PTR [eax+ecx]						;; comparer  l'quivalence de la table
		je Label3										;; si c'est gal  0, aller Label3
		jmp Label1									;; aller Label1

; ici la chane est trouve, alors on defini eax qui contiendra l'adresse 
Label4:	sub eax,edi									;; on soustrait l'adresse de la chane pour obtenir la position trouve dans la chane
		jmp Label6									;; aller Label6
Label5:	mov eax,-1									;; sinon on met -1 (chane non trouve dans eax)
Label6:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
ChercherChaineAscii_NonSensibleCasse_Ascendante ENDP


ALIGN 16
;
; trouver une chaine de caractres dans une chane/un texte ascii (la premire occurrence)
;
; Rceptionne :
; eax = position de dpart dans la chane
; esi = adresse de la chaine  trouver
; edi = adresse de la chaine/du texte  tester
;
; Retourne :
; eax = -1 si la chane de caractres n'est pas trouve, sinon eax contient la position o se situe cette chane
;
; syntaxe : ChercherChaineAscii_Descendante
;
ChercherChaineAscii_Descendante PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		add eax,edi									;; on ajoute la position  l'adresse de la chane
; on stocke le premier octet  trouver
		mov dh,BYTE PTR [esi]							;; placer le premier octet  trouver dans dh
		inc eax										;; ajouter 1  l'adresse ( cause de la ligne qui suit...)
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )

; maintenant, recherche du premier caractre identique
Label1:	dec eax										;; enlever 1  l'adresse de loctet  comparer
		cmp eax,edi									;; comparer eax  edi (l'adresse minimale)
		jb Label4										;; si c'est infrieur, aller Label4
		mov dl,BYTE PTR [eax]							;; lire l'octet  comparer, et le placer dans dl
		cmp dh,dl										;; sinon, comparer l'octet lu  celui en dh
		jne Label1									;; si c'est diffrent, on continu la recherche, aller Label1

; sinon, on teste les caractres suivants 
		xor ecx,ecx									;; effacer ecx
Label2:	inc ecx										;; augmenter ecx d'1
		mov dl,BYTE PTR [esi+ecx]						;; placer l'octet suivant dans dl
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		cmp dl,BYTE PTR [eax+ecx]						;; et le comparer  l'octet suivant  comparer
		je Label2										;; si c'est gal  0, aller Label2
		jmp Label1									;; aller Label1

; ici la chane est trouve, alors on defini eax qui contiendra l'adresse 
Label3:	sub eax,edi									;; on soustrait l'adresse de la chane pour obtenir la position trouve dans la chane
		jmp Label5									;; aller Label5
Label4:	mov eax,-1									;; sinon on met -1 (chane non trouve dans eax)
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
ChercherChaineAscii_Descendante ENDP


ALIGN 16
;
; comparer une chane de caractres  une autre, sans tenir compte de la casse de caractres
;
; Rceptionne :
; esi = adresse de la premire chane
; edi = adresse de la deuxime chane
;
; Retourne :
; eax = -1 si les chanes sont semblables, sinon eax contient la position (l'octet du bloc) o se situe la premire diffrence
;
; syntaxe : ComparerChainesAscii_NonSensibleCasse
;
ComparerChainesAscii_NonSensibleCasse PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx

		mov ebx,OFFSET _ChChAs_NSC_						;; placer l'adresse de la table dans ebx
		mov ecx,-1									;; placer -1 dans ecx
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
Label1:	inc ecx										;; ajouter 1  l'adresse en ecx
		mov al,BYTE PTR [esi+ecx]						;; placer l'octet en esi+ecx dans al
		cmp al,BYTE PTR [edi+ecx]						;; comparer al  l'octet en edi+ecx
		je Label2										;; si c'est semblable, aller Label2
		xlatb										;; changer al avec l'quivalence dans la table
		cmp al,BYTE PTR [edi+ecx]						;; comparer l'quivalence de la table  l'octet en edi+ecx
		jne Label3									;; si c'est diffrent, aller Label3
Label2:	test al,al									;; sinon, c'est semblable alors on va fixer les flags de al
		jnz Label1									;; si al est diffrent de 0, on retourne Label1
		mov eax,-1									;; placer -1 (pas de diffrence trouve) dans eax
		jmp Label4									;; sinon on sort de la routine en allant Label4
Label3:	mov eax,ecx									;; ici on place ecx dans eax (pour obtenir l'endroit de la diffrence)
Label4:
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
ComparerChainesAscii_NonSensibleCasse ENDP


ALIGN 16
;
; convertir une chaine dcimale (10 caractres valides au maximum) en valeur dans eax (32 bits) (fait jusqu'a 64 cycles)
;
; Rceptionne :
; esi = adresse de la chaine  lire
;
; Retourne :
; eax = la valeur
;
; syntaxe : ConvertirChaineDecimaleEnValeur
;
ConvertirChaineDecimaleEnValeur PROC
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor eax,eax									;; mettre eax  zro
		mov edx,eax									;; ainsi que edx
		nop											;; alignement ncessaire pour un meilleur rendement
Label0:	lea eax,[4*eax+eax]								;; ) multiplier eax par 10 et ajouter edx
		lea eax,[2*eax+edx]								;; )
Label1:	movzx edx,BYTE PTR [esi]							;; placer le caractre dans edx
		test edx,edx									;; fixer les flags de edx
		jz Label2										;; si edx est gal  0, aller Label2
		inc esi										;; incrementer l'adresse de la variable
;		cmp edx," "									;; (optionnel) on regarde si c'est un espace vide
;		je Label1										;;		)
		sub edx,"0"									;; sinon, soustraire le caractre de base  edx
		jmp Label0									;; et retourner lire le prochain caractre au Label0
Label2:
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
ConvertirChaineDecimaleEnValeur ENDP


ALIGN 16
;
; convertir une chaine hexadcimale (8 caractres valides au maximum) en valeur dans eax (32 bits)
;
; Rceptionne :
; esi = adresse de la chaine  lire
;
; Retourne :
; eax = la valeur
;
; syntaxe : ConvertirChaineHexaEnValeur
;
ConvertirChaineHexaEnValeur PROC
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor eax,eax									;; mettre eax  zro
		mov edx,eax									;; et galement edx
		nop											;; alignement ncessaire pour un meilleur rendement
Label1:	shl eax,4										;; multiplier eax par 16
		add eax,edx									;; et ajouter edx
Label2:	movzx edx,BYTE PTR [esi]							;; placer le caractre dans edx
		test edx,edx									;; ) on regarde si c'est la fin de chaine
		jz Label5										;; )
		inc esi										;; incrementer l'adresse de la variable
;		cmp edx," "									;; (optionnel) on regarde si c'est un espace vide
;		je Label2										;;		)
		cmp edx,"a"									;; comparer edx  "a"
		jae Label3									;; si c'est suprieur ou gal, aller Label3
		cmp edx,"A"									;; comparer edx  "A"
		jae Label4									;; si c'est suprieur ou gal, aller Label4
		sub edx,"0"									;; sinon, soustraire le caractre de base  eax
		jmp Label1									;; et retourner Label1
Label3:	sub edx,"W"									;; soustraire "a"-10
		jmp Label1									;; et aller Label1
Label4:	sub edx,"7"									;; soustraire "A"-10
		jmp Label1									;; et aller Label1
Label5:
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
ConvertirChaineHexaEnValeur ENDP


ALIGN 16
;
; convertir un motlong en texte au format dcimale (routine la plus stable) (fait jusqu'a 66 cycles)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;
; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineDecimale
;
ConvertirValeurEnChaineDecimale PROC
		push eax										;; empiler eax
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		mov ecx,eax									;; copier eax dans ecx

; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768								;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx										;; multiplier eax par 2814749768
		shr edx,16									;; dcaler edx de 16 bits  droite
		mov eax,100000									;; placer 100000 dans eax
		mov ebx,edx									;; copier edx dans ebx
		mul edx										;; multiplier edx par 100000
		sub ecx,eax									;; soustraire le rsultat en eax  ecx
		test ebx,ebx									;; fixer les flags de ebx
		mov edx,ebx									;; replacer ebx dans edx
		mov ebx,10									;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01									;; si c'est gal  0, aller Label01

; sinon, on traite la partie suprieure du nombre
		mov eax,429497									;; on remplace eax par 429497
		mul edx										;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02									;; s'il existe un dpassement, aller Label02
		mul ebx										;; multiplier eax par 10
		jc Label03									;; s'il existe un dpassement, aller Label03
		mul ebx										;; multiplier eax par 10
		jc Label04									;; s'il existe un dpassement, aller Label04
		mul ebx										;; multiplier eax par 10
		jc Label05									;; s'il existe un dpassement, aller Label05
		mul ebx										;; multiplier eax par 10
		jc Label06									;; s'il existe un dpassement, aller Label06

; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07									;; s'il existe un dpassement, aller Label07
		mul ebx										;; multiplier eax par 10
		jc Label08									;; s'il existe un dpassement, aller Label08
		mul ebx										;; multiplier eax par 10
		jc Label09									;; s'il existe un dpassement, aller Label09
		mul ebx										;; multiplier eax par 10
		jc Label10									;; s'il existe un dpassement, aller Label10
		mul ebx										;; multiplier eax par 10
		jmp Label11									;; aller Label11

; maintenant on va calculer et copier chaque octets/caractres
Label02:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label03:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label04:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label05:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label06:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi

		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label07:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label08:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label09:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label10:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label11:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mov BYTE PTR [esi+1],0							;; placer le 0 final  l'adresse en esi+1
		xor eax,eax									;; effacer eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


ALIGN 16
;
; convertir un motlong en texte au format hexadcimal (fait jusqu' 85 cycles)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;
; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineHexa
;
ConvertirValeurEnChaineHexa PROC
		push eax										;; empiler eax
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

;		mov BYTE PTR [esi],"0"							;; (optionnel) placer un "0" en tte de chane pour eviter des erreurs
;		inc esi										;;		) et incrmenter esi
		mov edi,esi									;; sauvegarder l'adresse ou commence le nombre dans edi
Label1:	mov edx,eax									;; rcupre la valeur actuelle
		and edx,0000000Fh								;; conserver les bits necessaires
		cmp edx,10									;; comparer la valeur  10
		jb Label2										;; si infrieur, aller Label2
		add edx,"7"									;; soustraire 10, et ajouter le caractre de base "A"
		jmp Label3									;; sauter a Label3
Label2:	add edx,"0"									;; ajouter le caractre de base
Label3:	mov BYTE PTR [edi],dl							;; sauvegarde du caractre
		shr eax,4										;; dcalage de 4 bits  droite
		inc edi										;; incrmenter edi
		test eax,eax									;; fixer les flags de eax
		jnz Label1									;; tant que eax est diffrent de 0, aller Label1
		mov BYTE PTR [edi],0							;; (optionnel) placer le 0 final

; maintenant, on inverse les octets obtenus
Label4:	dec edi										;; dcrmenter edi
		mov dl,BYTE PTR [esi]							;; placer l'octet  l'adresse en esi dans dl
		mov dh,BYTE PTR [edi]							;; placer l'octet  l'adresse en edi dans dh
		mov BYTE PTR [edi],dl							;; placer dl  l'adresse en edi
		mov BYTE PTR [esi],dh							;; placer dh  l'adresse en esi
		inc esi										;; incrmenter esi
		cmp esi,edi									;; comparer esi  edi
		jb Label4										;; tant que esi est infrieur  edi, aller Label4

		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
ConvertirValeurEnChaineHexa ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


.CODE
ALIGN 16
;
; copier une chane de caractres dans une autre chane
; note : videment, les tailles doivent tre valides pour les chanes source et destination
;
; Rceptionne :
; esi = adresse de la chane source.
; edi = adresse dans la chane de destination
;
; Retourne :
; eax = nombre de caractres copis (c-a-d la taille de la chane)
;
; syntaxe : CopierChaineAscii
;
CopierChaineAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label2									;; aller Label2
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
Label1:	add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],edx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label2:	mov ecx,DWORD PTR [esi+eax]						;; placer le motlong de l'adresse actuelle dans eax
		lea edx,[ecx-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor ecx,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and ecx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ecx,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de ecx
		mov [edi+eax],dl								;; placer dl  l'adresse en edi+eax
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],dh								;; placer dh  l'adresse en edi+eax+1
		test dh,dh									;; fixer les flags de dh
		jz Label4										;; si c'est gal  0, aller Label4
		shr edx,16									;; dcaler edx  droite de 16 bits
		mov [edi+eax+2],dl								;; placer dl  l'adresse en edi+eax+2
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],dh								;; placer dh  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label3:	inc eax										;; ajouter 1  eax )
Label4:	inc eax										;; ajouter 1  eax )
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierChaineAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
;
; Rceptionne :
; esi = adresse de la chane source que l'on ajoutera
; edi = adresse de la chane de destination
;
; Retourne :
; eax = la taille de la nouvelle chaine obtenue
;
; syntaxe : FusionnerChainesAscii
;
FusionnerChainesAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; placer le motlong de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; placer edi + edx - 1 dword dans edi

; et on effectue la copie
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label3									;; aller Label3
Label2:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label3:	mov edx,DWORD PTR [esi+eax]						;; placer le motlong de l'adresse actuelle dans eax
		lea ecx,[edx-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans ecx
		xor edx,ecx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label2										;; si le filtrage est gal  0, aller Label2
		and edx,ecx									;; ne conserver en eax que les bits positionns en ecx
		jz Label2										;; si le filtrage est gal  0, aller Label2
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; placer cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label6										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],ch								;; placer ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label5										;; si c'est gal  0, aller Label4
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; placer cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label4										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],ch								;; placer ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label4:	inc eax										;; ajouter 1  eax )
Label5:	inc eax										;; ajouter 1  eax )
Label6:	add eax,edi									;; ajouter edi  eax

		pop edi										;; dsempiler edi
		sub eax,edi									;; et on soustrait l'adresse originelle  eax pour obtenir la nouvelle taille de la chane
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
FusionnerChainesAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
;
; Rceptionne :
; edi = adresse de la chane de destination
; le nombre de chaines  ajouter (1 au minimum) (qui servira de compteur)
; et les adresses des diffrentes chanes sources que l'on ajoutera
;
; Retourne :
; eax = la taille de la nouvelle chaine obtenue
;
; syntaxe : FusionnerMultiplesChainesAscii [nombre de chaines  ajouter],[adresse de la chane source1],[adresse de la chane source2],...
;
FusionnerMultiplesChainesAscii PROC C _Compteur_:DWORD,_Adresse_Sources_:VARARG
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

		lea esi,_Adresse_Sources_						;; placer l'adresse de la premire chane source dans esi
		nop											;; alignement ncessaire pour un meilleur rendement

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; placer le motlong de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; placer edi + edx - 1 dword dans edi

; ensuite on va prparer nos copie de chaines
		xor ebx,ebx									;; effacer ebx (notre compteur de chanes)
Label2:	push ebx										;; empiler ebx (parcequ'on  plus de registres libres)
		mov ebx,[4*ebx+esi]								;; placer l'adresse de la nouvelle source dans ebx
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label4									;; aller Label4

; et on effectue nos copies
Label3:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter eax (notre compteur d'octets) de 4 (un dword)
Label4:	mov edx,DWORD PTR [ebx+eax]						;; placer le motlong de l'adresse actuelle dans edx
		lea ecx,[edx-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans ecx
		xor edx,ecx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label3										;; si le filtrage est gal  0, aller Label3
		and edx,ecx									;; ne conserver en edx que les bits positionns en ecx
		jz Label3										;; si le filtrage est gal  0, aller Label3
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; placer cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label7										;; si c'est gal  0, aller Label7
		mov [edi+eax+1],ch								;; placer ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label6										;; si c'est gal  0, aller Label6
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; placer cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+3],ch								;; placer ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax
Label5:	inc eax										;; ajouter 1  eax
Label6:	inc eax										;; ajouter 1  eax
Label7:	lea edi,[edi+eax]								;; ajouter eax+1  edi

; l on va tester s'il y a une autre source  ajouter
		pop ebx										;; dsempiler ebx (pour r-obtenir notre compteur de sources)
		inc ebx										;; ajouter 1 au nombre de source
		cmp ebx,_Compteur_								;; et le comparer  Compteur
		jne Label2									;; si c'est diffrent, aller Label2

; ici, on calcul la nouvelle taille de la chane...
		mov eax,edi									;; placer edi dans eax

		pop edi										;; dsempiler edi
		sub eax,edi									;; et soustraire AdresseDestination  eax pour obtenir la nouvelle taille de la chane
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
FusionnerMultiplesChainesAscii ENDP


ALIGN 16
;
; obtenir la taille relle d'une chane de caractres
;
; Rceptionne :
; esi = adresse de la chane dont on veut obtenir la taille
;
; Retourne :
; eax = taille relle de la chane
;
; syntaxe : ObtenirTailleChaineAscii
;
ObtenirTailleChaineAscii PROC
		push edx										;; empiler edx
		push esi										;; empiler esi

		nop
Label1:	mov eax,DWORD PTR [esi]							;; placer le motlong de l'adresse actuelle dans eax
		add esi,4										;; incrmenter esi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea eax,[esi+edx-4]								;; placer esi + edx - 1 dword dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		sub eax,esi									;; et soustraire l'adresse originelle au rsultat obtenu
	ret												;; retourner (sortir de la procdure)
ObtenirTailleChaineAscii ENDP


ALIGN 16
;
; supprimer les espaces, et tester la validit d'une chaine de caractres dcimale
;
; Rceptionne :
; esi = adresse de la chaine a tester
;
; Retourne :
; eax = -1 si la chaine est valide, sinon retourne la position de l'erreur
;
; syntaxe : TesterValiditeChaineDecimale
;
TesterValiditeChaineDecimale PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; premirement on supprime tout les espaces vides
		xor eax,eax									;; effacer eax
		mov edi,esi									;; placer l'adresse de la chane dans edi
		lea ecx,[esi-1]								;; placer une copie de edi-1 dans ecx
Label1:	dec edi										;; soustraire 1  edi
Label2:	inc eax										;; augmenter ecx
		mov dl,BYTE PTR [ecx+eax]						;; placer le caractre  lire dans dl
		cmp dl," "									;; comparer al au caractre  supprimer " "
		je Label1										;; si c'est gal au caractre  supprimer, aller Label1
		mov BYTE PTR [edi+eax],dl						;; et copier l'octet en ecx dans edi
		test dl,dl									;; fixer les flags de dl
		jnz Label2									;; si dl n'est pas gal  0, aller Label2

; ensuite on teste la validit de la chane...
		mov eax,-1									;; placer -1 (tout est ok) dans eax
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
Label3:	inc ecx										;; incrementer l'adresse de la variable
		mov dl,BYTE PTR [ecx]							;; placer le caractre dans dl
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si dl est gal  0, aller Label5 (la sortie)
		cmp dl,"0"									;; tester si le caractre est inferieur  0
		jb Label4										;; si c'est le cas aller Label4
		cmp dl,"9"									;; tester si le caractre est infrieur ou gal  9
		jbe Label3									;; si c'est le cas aller Label3
Label4:	mov eax,ecx									;; placer l'adresse de l'erreur dans eax, car la chaine n'est pas valide
		sub eax,esi									;; soustraire l'adresse de dpart pour obtenir la position
Label5:
		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
TesterValiditeChaineDecimale ENDP


ALIGN 16
;
; supprimer les espaces, et tester la validit d'une chaine de caractres hxadcimale
;
; Rceptionne :
; esi = adresse de la chaine a tester
;
; Retourne :
; eax = -1 si la chaine est valide, sinon retourne la position de l'erreur
;
; syntaxe : TesterValiditeChaineHexadecimale
;
TesterValiditeChaineHexadecimale PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; premirement on supprime tout les espaces vides
		xor eax,eax									;; effacer eax
		mov edi,esi									;; placer l'adresse de la chane dans edi
		lea ecx,[esi-1]								;; placer une copie de edi-1 dans ecx
Label1:	dec edi										;; soustraire 1  edi
Label2:	inc eax										;; augmenter ecx
		mov dl,BYTE PTR [ecx+eax]						;; placer le caractre  lire dans dl
		cmp dl," "									;; comparer dl au caractre  supprimer " "
		je Label1										;; si c'est gal au caractre  supprimer, aller Label1
		mov BYTE PTR [edi+eax],dl						;; et copier l'octet en ecx dans edi
		test dl,dl									;; fixer les flags de dl
		jnz Label2									;; si dl n'est pas gal  0, aller Label2

; ensuite on teste la validit de la chane...
		mov eax,-1									;; placer -1 (tout est ok) dans eax
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
Label3:	inc ecx										;; incrementer l'adresse de la variable
		mov dl,BYTE PTR [ecx]							;; placer le caractre dans dl
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si eax est gal  0, aller Label5 (la sortie)
		cmp dl,"0"									;; tester si le caractre est inferieur  0
		jb Label4										;; si c'est le cas aller Label 4
		cmp dl,"9"									;; tester si le caractre est inferieur ou gal  9
		jbe Label3									;; si c'est le cas aller Label 3
		cmp dl,"A"									;; tester si le caractre est inferieur  A
		jb Label4										;; si c'est le cas aller Label 4
		cmp dl,"F"									;; tester si le caractre est inferieur ou gal  F
		jbe Label3									;; si c'est le cas aller Label 3
		cmp dl,"a"									;; tester si le caractre est inferieur  a
		jb Label4										;; si c'est le cas aller Label 4
		cmp dl,"f"									;; tester si le caractre est infrieur ou gal  f
		jbe Label3									;; si c'est le cas aller Label 3
Label4:	mov eax,ecx									;; placer l'adresse de l'erreur dans eax, car la chaine n'est pas valide
		sub eax,esi									;; soustraire l'adresse de dpart pour obtenir la position
Label5:
		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
TesterValiditeChaineHexadecimale ENDP


